#include "AnagArrayLim.H"
#include "CONSTANTS.H"
#include "BC_TYPES.H"
#include "STATE_F.H"

#define numelem 4

        PROGRAM shipwave
        REAL_T dx(3),dxmin,dt,cfl,initshrink
        integer bc(2*BL_SPACEDIM)
        BL_BBOUNDS(domain)
        BL_BBOUNDS(domaingrow)
        BL_FBOUNDS(eblevel)
        BL_FBOUNDS(levelnode)
        BL_FBOUNDS(VolFrac)
        BL_FBOUNDS(Volume)
        BL_FBOUNDS(pressure)
        BL_FBOUNDS(areafrac)
        BL_FBOUNDS(area)
        BL_FBOUNDS(liquid_area)
        BL_FBOUNDS(state_area)
        BL_FBOUNDS(state)
        BL_FBOUNDS(newstate)
        BL_FBOUNDS(halfstate)
        BL_FBOUNDS(work)
        BL_FBOUNDS(mask)
        REAL_T, DIMENSION(:,:,:), ALLOCATABLE::eblevel,levelnode
        REAL_T, DIMENSION(:,:,:), ALLOCATABLE::VolFrac,Volume,pressure
        REAL_T, DIMENSION(:,:,:,:), ALLOCATABLE::areafrac,area
        REAL_T, DIMENSION(:,:,:,:), ALLOCATABLE::liquid_area,state_area
        REAL_T, DIMENSION(:,:,:,:), ALLOCATABLE::state,newstate,halfstate
        REAL_T, DIMENSION(:,:,:,:), ALLOCATABLE::work
        integer, DIMENSION(:,:,:), ALLOCATABLE::mask
        integer i,j,k
        REAL_T t,t_start,dtsave,shrinkvar
        integer dir,initial_step,nvar,n,plot_n,plot_n_start
        integer geometrytype,irestart,icheckint
        integer localnx,localny,localnz,imax,jmax,kmax
        REAL_T prob_lo(3),prob_hi(3)

#include "probdata.H"

        localnx=128
        localny=96
        localnz=96
        imax=2*NGROW+localnx
        jmax=2*NGROW+localny
        kmax=2*NGROW+localnz
        ALLOCATE(eblevel(imax,jmax,kmax))
        ALLOCATE(levelnode(imax,jmax,kmax))
        ALLOCATE(VolFrac(imax,jmax,kmax))
        ALLOCATE(Volume(imax,jmax,kmax))
        ALLOCATE(pressure(imax,jmax,kmax))
        ALLOCATE(areafrac(imax,jmax,kmax,BL_SPACEDIM))
        ALLOCATE(area(imax,jmax,kmax,BL_SPACEDIM))
        ALLOCATE(liquid_area(imax,jmax,kmax,BL_SPACEDIM))
        ALLOCATE(state_area(imax,jmax,kmax,BL_SPACEDIM))
        ALLOCATE(state(imax,jmax,kmax,QNUM))
        ALLOCATE(newstate(imax,jmax,kmax,QNUM))
        ALLOCATE(halfstate(imax,jmax,kmax,QNUM))
        ALLOCATE(work(imax,jmax,kmax,WNUM))
        ALLOCATE(mask(imax,jmax,kmax))

        irestart=1
        icheckint=10
        liquidonly=0
        rz=0
        geometrytype=3
        probtype= 6
c  REFLECT_ODD -1 INT_DIR 0 REFLECT_EVEN 1 EXTRAP  2 EXT_DIR 3  HOEXTRAP 4
        bcxlo= 0
        bcxhi= 0
        bcylo= 0
        bcyhi= 0
        bczlo= 1
        bczhi= 1
        verbose= 1
        max_n= 10000
        tMax= 0.99
        dwedge= 0.5
        alpha= 0.999
        xdomain= 2.0
        ydomain= 0.5
        zdomain= 0.5
        xblob= 1.0
        yblob=0.25
        zblob= 0.25
        xslice=1.0
        yslice=0.25
        zslice=0.25
        rad1= 1.0
        rad2= 0.25
        speed= 1.0
        denair=0.001225
        denwater=1.0
        gravity=-6.0
        adv_dir=1
        viscair=1.0
        viscwater=1.0
        visccoeff=0.0
        visctheta=1.0
        tension=0.0
        spread=3
        cfl=0.3
        initshrink=0.5
  
        prob_lo(1)=zero
        prob_hi(1)=xdomain 
        prob_lo(2)=zero
        prob_hi(2)=ydomain 
        prob_lo(3)=zero
        prob_hi(3)=zdomain 

        bc(1)=bcxlo
        bc(2)=bcxhi
        bc(3)=bcylo
        bc(4)=bcyhi
        bc(5)=bczlo
        bc(6)=bczhi
   
        domainlo(1)=0
        domainhi(1)=localnx-1
        domainlo(2)=0
        domainhi(2)=localny-1
        domainlo(3)=0
        domainhi(3)=localnz-1
        domaingrowlo(1)=-NGROW
        domaingrowhi(1)=localnx+NGROW-1
        domaingrowlo(2)=-NGROW
        domaingrowhi(2)=localny+NGROW-1
        domaingrowlo(3)=-NGROW
        domaingrowhi(3)=localnz+NGROW-1

        eblevelloi1=domaingrowlo(1)
        eblevelloi2=domaingrowlo(2)
        eblevelloi3=domaingrowlo(3)
        eblevelhii1=domaingrowhi(1)
        eblevelhii2=domaingrowhi(2)
        eblevelhii3=domaingrowhi(3)

        levelnodeloi1=domaingrowlo(1)
        levelnodeloi2=domaingrowlo(2)
        levelnodeloi3=domaingrowlo(3)
        levelnodehii1=domaingrowhi(1)
        levelnodehii2=domaingrowhi(2)
        levelnodehii3=domaingrowhi(3)

        VolFracloi1=domaingrowlo(1)
        VolFracloi2=domaingrowlo(2)
        VolFracloi3=domaingrowlo(3)
        VolFrachii1=domaingrowhi(1)
        VolFrachii2=domaingrowhi(2)
        VolFrachii3=domaingrowhi(3)

        Volumeloi1=domaingrowlo(1)
        Volumeloi2=domaingrowlo(2)
        Volumeloi3=domaingrowlo(3)
        Volumehii1=domaingrowhi(1)
        Volumehii2=domaingrowhi(2)
        Volumehii3=domaingrowhi(3)

        pressureloi1=domaingrowlo(1)
        pressureloi2=domaingrowlo(2)
        pressureloi3=domaingrowlo(3)
        pressurehii1=domaingrowhi(1)
        pressurehii2=domaingrowhi(2)
        pressurehii3=domaingrowhi(3)

        areafracloi1=domaingrowlo(1)
        areafracloi2=domaingrowlo(2)
        areafracloi3=domaingrowlo(3)
        areafrachii1=domaingrowhi(1)
        areafrachii2=domaingrowhi(2)
        areafrachii3=domaingrowhi(3)


        arealoi1=domaingrowlo(1)
        arealoi2=domaingrowlo(2)
        arealoi3=domaingrowlo(3)
        areahii1=domaingrowhi(1)
        areahii2=domaingrowhi(2)
        areahii3=domaingrowhi(3)


        liquid_arealoi1=domaingrowlo(1)
        liquid_arealoi2=domaingrowlo(2)
        liquid_arealoi3=domaingrowlo(3)
        liquid_areahii1=domaingrowhi(1)
        liquid_areahii2=domaingrowhi(2)
        liquid_areahii3=domaingrowhi(3)

        state_arealoi1=domaingrowlo(1)
        state_arealoi2=domaingrowlo(2)
        state_arealoi3=domaingrowlo(3)
        state_areahii1=domaingrowhi(1)
        state_areahii2=domaingrowhi(2)
        state_areahii3=domaingrowhi(3)

        stateloi1=domaingrowlo(1)
        stateloi2=domaingrowlo(2)
        stateloi3=domaingrowlo(3)
        statehii1=domaingrowhi(1)
        statehii2=domaingrowhi(2)
        statehii3=domaingrowhi(3)


        newstateloi1=domaingrowlo(1)
        newstateloi2=domaingrowlo(2)
        newstateloi3=domaingrowlo(3)
        newstatehii1=domaingrowhi(1)
        newstatehii2=domaingrowhi(2)
        newstatehii3=domaingrowhi(3)


        halfstateloi1=domaingrowlo(1)
        halfstateloi2=domaingrowlo(2)
        halfstateloi3=domaingrowlo(3)
        halfstatehii1=domaingrowhi(1)
        halfstatehii2=domaingrowhi(2)
        halfstatehii3=domaingrowhi(3)


        workloi1=domaingrowlo(1)
        workloi2=domaingrowlo(2)
        workloi3=domaingrowlo(3)
        workhii1=domaingrowhi(1)
        workhii2=domaingrowhi(2)
        workhii3=domaingrowhi(3)

        maskloi1=domaingrowlo(1)
        maskloi2=domaingrowlo(2)
        maskloi3=domaingrowlo(3)
        maskhii1=domaingrowhi(1)
        maskhii2=domaingrowhi(2)
        maskhii3=domaingrowhi(3)

        dx(1)=xdomain/localnx
        dx(2)=ydomain/localny
        dx(3)=zdomain/localnz
        if ((dx(1).lt.dx(2)).and.(dx(1).lt.dx(3))) then
         dxmin=dx(1)
        else if (dx(2).lt.dx(3)) then
         dxmin=dx(2)
        else
         dxmin=dx(3)
        endif
 
        do i=1,imax
        do j=1,jmax
        do k=1,kmax
         VolFrac(i,j,k)=zero
         mask(i,j,k)=0
         pressure(i,j,k)=zero
         do m=1,QNUM
          state(i,j,k,m)=zero
          newstate(i,j,k,m)=zero
          halfstate(i,j,k,m)=zero
         enddo
        enddo
        enddo
        enddo

        print *,"dxmin prior to INITGEOM ",dxmin
        call FORT_INITGEOMETRY(geometrytype,bc,BL_BARG(domain),
     &    BL_BARG(domaingrow),
     &    dx,BL_FARG(eblevel),BL_FARG(levelnode),
     &    BL_FARG(volfrac),BL_FARG(areafrac),
     &    BL_FARG(volume),BL_FARG(area),BL_FARG(mask) )

        print *,"dxmin after ",dxmin

        if (irestart.eq.0) then
         print *,"initializing data...."
         call FORT_PROBINIT(BL_FARG(state),dx,bc,
     &    BL_BARG(domain),BL_BARG(domaingrow),
     &    BL_FARG(volfrac),BL_FARG(areafrac),
     &    BL_FARG(volume),BL_FARG(area),BL_FARG(levelnode),
     &    BL_FARG(liquid_area),BL_FARG(state_area),
     &    prob_lo,prob_hi,BL_FARG(work) )
         print *,"before getdt ",dxmin
         call FORT_GETDT(BL_FARG(state),initshrink,dxmin,
     &    cfl,dt,BL_BARG(domain),BL_BARG(domaingrow),bc)
         plot_n_start=0
         t_start=zero
         plot_n=0
         t=zero
         call writerestart(plot_n,t,dt,BL_FARG(state),
     &      BL_FARG(pressure),BL_BARG(domaingrow),BL_BARG(domain),
     &      BL_FARG(eblevel),BL_FARG(VolFrac),dx,BL_FARG(work),bc)
        else
         print *,"opening restart file: check"
         open(unit=11,file='check',form='formatted',status='old')
         read(11,51) plot_n_start,t_start,dt
         print *,"plot_n_start,t_start,dt ",plot_n_start,t_start,dt
        
         do i=1,imax
         do j=1,jmax
         do k=1,kmax
          read (11,101) state(i,j,k,QVFRAC),state(i,j,k,QLEVEL),
     &      STATE(i,j,k,QVEL1),STATE(i,j,k,QVEL2),
     &      STATE(i,j,k,QVEL3),work(i,j,k,WSOLN)

          pressure(i,j,k)=work(i,j,k,WSOLN)
         enddo
         enddo
         enddo
         close(11)
        endif
51      FORMAT(I10,e20.14,e20.14)
101     FORMAT(e20.14,e20.14,e20.14,e20.14,e20.14,e20.14)

        t=t_start
        do plot_n=plot_n_start,max_n
         if (t.gt.tMax-1.0E-7) then
          goto 10
         endif
         print *,"STEP,DT,TIME ",plot_n,dt,t
         if (plot_n.ne.0) then
          shrinkvar=one
          dtsave=dt
          call FORT_GETDT(BL_FARG(state),shrinkvar,dxmin,
     &     cfl,dt,BL_BARG(domain),BL_BARG(domaingrow),bc)
          if (dt.gt.dtsave*1.1) then
           dt=dtsave*1.1
          endif
          if (t+dt.gt.tMax) then
           dt=tMax-t
          endif
         endif
         do i=1,imax
         do j=1,jmax
         do k=1,kmax
         do m=1,QNUM
          newstate(i,j,k,m)=state(i,j,k,m)
          halfstate(i,j,k,m)=state(i,j,k,m)
         enddo
         enddo
         enddo
         enddo
         call FORT_ADVANCE(BL_FARG(state),
     &     BL_FARG(newstate),BL_FARG(halfstate),dx,dt,initial_step,bc,
     &     BL_BARG(domain),BL_BARG(domaingrow),
     &     BL_FARG(eblevel),BL_FARG(levelnode),
     &     BL_FARG(volfrac),BL_FARG(areafrac),
     &     BL_FARG(volume),BL_FARG(area),
     &     prob_lo,prob_hi,plot_n,nvar,t,
     &     BL_FARG(liquid_area),BL_FARG(state_area),
     &     BL_FARG(work) )

         do i=1,imax
         do j=1,jmax
         do k=1,kmax
          pressure(i,j,k)=work(i,j,k,WSOLN)
          do m=1,QNUM
           state(i,j,k,m)=newstate(i,j,k,m)
          enddo
         enddo
         enddo
         enddo

         t=t+dt
         if (plot_n+1-icheckint*((plot_n+1)/icheckint).eq.0) then
          call writerestart(plot_n,t,dt,BL_FARG(state),
     &      BL_FARG(pressure),BL_BARG(domaingrow),BL_BARG(domain),
     &      BL_FARG(eblevel),BL_FARG(VolFrac),dx,BL_FARG(work),bc)
         endif
        enddo
10      continue

50      FORMAT(I10,e20.14,e20.14)
100     FORMAT(e20.14,e20.14,e20.14,e20.14,e20.14,e20.14)

        DEALLOCATE(mask)
        DEALLOCATE(work,halfstate,newstate,state)
        DEALLOCATE(state_area,liquid_area)
        DEALLOCATE(area,areafrac,pressure)
        DEALLOCATE(Volume,VolFrac,eblevel,levelnode)

        STOP
        END



        subroutine writerestart(plot_n,t,dt,BL_FARG(state),
     &     BL_FARG(pressure),BL_BARG(domaingrow),BL_BARG(domain),
     &     BL_FARG(eblevel),BL_FARG(VolFrac),dx,BL_FARG(work),bc)
        BL_BBOUNDS(domaingrow)
        BL_BBOUNDS(domain)
        BL_FBOUNDS(state)
        BL_FBOUNDS(pressure)
        BL_FBOUNDS(eblevel)
        BL_FBOUNDS(VolFrac)
        BL_FBOUNDS(work)

        BL_FARRAY1(VolFrac)
        BL_FARRAY(state,QNUM)
        BL_FARRAY1(eblevel)
        BL_FARRAY1(pressure)
        BL_FARRAY(work,WNUM)
        integer bc(2*BL_SPACEDIM)
        REAL_T dx(3),t,dt
        integer plot_n
        integer i,j,k,imax,jmax,kmax
        CHARACTER*35 SYSCMD
        integer SYSRET, SYSTEM
        BL_FBOUNDS(tracer)
        REAL_T, DIMENSION(:,:,:), ALLOCATABLE::tracer

#include "probdata.H"

        print *, " writing surface files..."
        imax=domainhi(1)-domainlo(1)+1
        jmax=domainhi(2)-domainlo(2)+1
        kmax=domainhi(3)-domainlo(3)+1
        tracerloi1=domainlo(1)
        tracerloi2=domainlo(2)
        tracerloi3=domainlo(3)
        tracerhii1=domainhi(1)
        tracerhii2=domainhi(2)
        tracerhii3=domainhi(3)
        ALLOCATE(tracer(imax,jmax,kmax))
        call FORT_MAKETRACER(BL_FARG(state),BL_FARG(tracer),
     &    BL_BARG(domain),BL_BARG(domaingrow),
     &    BL_FARG(eblevel),BL_FARG(volfrac),dx,
     &    BL_FARG(work),bc)

        DEALLOCATE(tracer)

        print *, " writing check file... "
        open(unit=11,file='check',form='formatted',
     &     status='unknown')
        write (11,50) plot_n,t,dt 

        do i=domaingrowlo(1),domaingrowhi(1)
        do j=domaingrowlo(2),domaingrowhi(2)
        do k=domaingrowlo(3),domaingrowhi(3)
         write (11,100) state(i,j,k,QVFRAC),state(i,j,k,QLEVEL),
     &      STATE(i,j,k,QVEL1),STATE(i,j,k,QVEL2),
     &      STATE(i,j,k,QVEL3),pressure(i,j,k)
        enddo
        enddo
        enddo

! here is my system call
!        SYSCMD='ls -alF; sleep 30'
        SYSCMD='/home/beason/sussman/isosurf/myiso'
        SYSRET=SYSTEM(SYSCMD)
        
        close(11)

50      FORMAT(I10,e20.14,e20.14)
100     FORMAT(e20.14,e20.14,e20.14,e20.14,e20.14,e20.14)

        return
        end

        subroutine setindex(dir,ii,jj,kk)
        integer dir,ii,jj,kk
 
        ii=0
        jj=0
        kk=0 
        if (dir.eq.1) then
         ii=1
        else if (dir.eq.2) then
         jj=1
        else if ((BL_SPACEDIM.eq.2).or.(dir.gt.3)) then
         print *,"dir out of range in setindex"
        else if (dir.eq.3) then
         kk=1
        endif

        return
        end

        REAL_T function eno(a,b)
        REAL_T a,b

        if (abs(a).gt.abs(b)) then
         eno=b
        else
         eno=a
        endif

        return
        end

        subroutine nonlinear(i,j,k,advect,BL_FARG(newstate),
     &     BL_FARG(halfstate),source,dx,dt,BL_FARG(areafrac) )
        BL_FBOUNDS(halfstate)
        BL_FARRAY(halfstate,QNUM) 
        BL_FBOUNDS(newstate)
        BL_FARRAY(newstate,QNUM) 
        BL_FBOUNDS(areafrac)
        BL_FARRAY(areafrac,BL_SPACEDIM) 
        REAL_T advect(BL_SPACEDIM),dx(3),dt
        integer i,j,k,source,sourcedir
        integer dir,ii,jj,kk
        REAL_T eno,fluxhi,fluxlo,fluxdiff,fluxlim

        sourcedir=source-QVEL1+1 
        if (areafrac(i,j,k,sourcedir).gt.zero) then
         do dir=1,BL_SPACEDIM
          call setindex(dir,ii,jj,kk)

          if (advect(dir).ge.zero) then
           fluxhi=halfstate(i,j,k,source)+half*eno(
     &      halfstate(i+ii,j+jj,k+kk,source)-halfstate(i,j,k,source),
     &      halfstate(i,j,k,source)-halfstate(i-ii,j-jj,k-kk,source) ) 
           fluxlo=halfstate(i-ii,j-jj,k-kk,source)+half*eno( 
     &      halfstate(i,j,k,source)-halfstate(i-ii,j-jj,k-kk,source),
     &      halfstate(i-ii,j-jj,k-kk,source)-
     &         halfstate(i-2*ii,j-2*jj,k-2*kk,source) ) 
          else
           fluxhi=halfstate(i+ii,j+jj,k+kk,source)-half*eno(
     &      halfstate(i+2*ii,j+2*jj,k+2*kk,source)-
     &         halfstate(i+ii,j+jj,k+kk,source),
     &      halfstate(i+ii,j+jj,k+kk,source)-halfstate(i,j,k,source) ) 
           fluxlo=halfstate(i,j,k,source)-half*eno( 
     &      halfstate(i+ii,j+jj,k+kk,source)-halfstate(i,j,k,source),
     &      halfstate(i,j,k,source)-halfstate(i-ii,j-jj,k-kk,source) ) 
          endif
          fluxdiff=fluxhi-fluxlo

          newstate(i,j,k,source)=newstate(i,j,k,source)-
     &     dt*advect(dir)*fluxdiff/dx(dir)
         enddo
        endif

        return
        end


        subroutine normallvl(lvlset,dx,dy,dz,nx,ny,nz)
        REAL_T lvlset(3,3,3),dx,dy,dz,nx,ny,nz,dist

        nx=-(lvlset(3,2,2)-lvlset(1,2,2))/(two*dx)
        ny=-(lvlset(2,3,2)-lvlset(2,1,2))/(two*dy)
        nz=-(lvlset(2,2,3)-lvlset(2,2,1))/(two*dz)
        dist=sqrt(nx**2+ny**2+nz**2)
        if (dist.eq.zero) then
         print *,"dist is zero"
        else
         nx=nx/dist
         ny=ny/dist
         nz=nz/dist
        endif

        return
        end

        subroutine checkeasy(lvlset,iflag)
        REAL_T lvlset(3,3,3)
        integer iflag

        integer i1,j1,k1

        iflag=0

        do i1=1,3
        do j1=1,3
        do k1=1,3
         if (lvlset(2,2,2)*lvlset(i1,j1,k1).le.zero) then
          iflag=1
         endif
        enddo
        enddo
        enddo

        return 
        end

        subroutine checkline(lvlset,iflag)
        REAL_T lvlset(3,3,3)
        integer iflag

        integer minusflag,plusflag,i1,j1,k1
        REAL_T levelmid

        minusflag=0
        plusflag=0

        do i1=1,3
        do j1=1,3
        do k1=1,3
         levelmid=half*(lvlset(2,2,2)+lvlset(i1,j1,k1))
         if (levelmid.le.zero) then
          minusflag=1
         endif 
         if (levelmid.ge.zero) then
          plusflag=1
         endif
        enddo
        enddo
        enddo
        if ((minusflag.eq.1).and.(plusflag.eq.1)) then
          iflag=1
        else
          iflag=0
        endif

        return 
        end

        subroutine checkbox(x,y,z,inbox,dx,dy,dz)
        REAL_T x,y,z,dx,dy,dz
        integer inbox

        if ((x.lt.zero).or.(x.gt.dx).or.(y.lt.zero).or.(y.gt.dy).or.
     &      (z.lt.zero).or.(z.gt.dz)) then
         inbox=0
        else
         inbox=1
        endif
 
        return
        end

        subroutine dist1d(ydiff,z,nz,arclen,distnew,inboxnew,dx,dy,dz)
        REAL_T ydiff,z,nz,arclen,distnew,dx,dy,dz
        integer inboxnew
        REAL_T dist2,nz2,arclen2,phi,xint,yint,zint

        dist2=abs(nz)
        if ((dist2.eq.zero).and.(arclen.eq.zero)) then
         if (z.le.zero) then
          distnew=sqrt((ydiff)**2+z**2)
         else
          distnew=sqrt((ydiff)**2+(z-dz)**2) 
         endif
         inboxnew=1
        else if (dist2.eq.zero) then
         inboxnew=0
        else
         nz2=nz/dist2
         arclen2=arclen/dist2
         phi=nz2*z+arclen2
         xint=half*dx
         yint=half*dy
         zint=z-nz2*phi
         call checkbox(xint,yint,zint,inboxnew,dx,dy,dz)
         if (inboxnew.eq.1) then
          distnew=sqrt( ydiff**2 + phi**2 )
         endif
        endif

        return
        end

c dx,dy,dz are reordered to match the xdiff,y,z parameters
        subroutine dist2d(xdiff,y,z,ny,nz,arclen,distnew,inboxnew,
     &     dx,dy,dz)
        REAL_T xdiff,y,z,ny,nz,arclen,distnew,dx,dy,dz
        integer inboxnew

        REAL_T dist2,ny2,nz2,arclen2,phi,xint,yint,zint
        REAL_T dist(5),mindist
        integer inbox(5),initflag,ii

        dist2=sqrt(ny**2+nz**2)
        if ((dist2.eq.zero).and.(arclen.eq.zero)) then
         if ((y.le.zero).and.(z.le.zero)) then
          distnew=sqrt((xdiff)**2 + y**2 + z**2 )
         else if (z.le.zero) then
          distnew=sqrt((xdiff)**2 + (y-dy)**2 + z**2)
         else if (y.le.zero) then
          distnew=sqrt((xdiff)**2 + y**2 + (z-dz)**2 )
         else
          distnew=sqrt((xdiff)**2 + (y-dy)**2 + (z-dz)**2 )
         endif 
         inboxnew=1
        else if (dist2.eq.zero) then
         inboxnew=0
        else
         ny2=ny/dist2
         nz2=nz/dist2
         arclen2=arclen/dist2
         phi=ny2*y+nz2*z+arclen2
         yint=y-ny2*phi
         zint=z-nz2*phi
         xint=half*dx
         call checkbox(xint,yint,zint,inbox(1),dx,dy,dz)
         if (inbox(1).eq.0) then
          call dist1d(y,z,nz2,arclen2,dist(2),inbox(2),dx,dy,dz)
          call dist1d(y-dy,z,nz2,arclen2+ny2*dy,dist(3),inbox(3),dx,dy,dz)
          call dist1d(z,y,ny2,arclen2,dist(4),inbox(4),dx,dz,dy)
          call dist1d(z-dz,y,ny2,arclen2+nz2*dz,dist(5),inbox(5),dx,dz,dy)
          initflag=0
          do ii=2,5
           if (inbox(ii).eq.1) then
            if (initflag.eq.0) then
             mindist=dist(ii)
             initflag=1
            else if (dist(ii).lt.mindist) then
             mindist=dist(ii)
            endif
           endif
          enddo
          if (initflag.eq.0) then
           inboxnew=0
          else
           inboxnew=1
           distnew=sqrt( xdiff**2 + mindist**2 ) 
          endif
         else
          inboxnew=1
          distnew=sqrt( xdiff**2 + phi**2 ) 
         endif
        endif
          
        return
        end


        subroutine distcheck(BL_BARG(domain),BL_BARG(domaingrow),
     &    BL_FARG(newstate),BL_FARG(work),
     &    BL_FARG(volfrac),bc,ialt,jalt,kalt,dxmax,
     &    facepoints,i,j,k )
        BL_BBOUNDS(domain)
        BL_BBOUNDS(domaingrow)
        BL_FBOUNDS(newstate)
        BL_FBOUNDS(work)
        BL_FBOUNDS(volfrac)
        BL_FARRAY1(volfrac)
        BL_FARRAY(newstate,QNUM)
        BL_FARRAY(work,WNUM)
 
        integer bc(2*BL_SPACEDIM),ialt,jalt,kalt,i,j,k
        REAL_T dxmax
        REAL_T  facepoints(3,3,3,3)

#include "probdata.H"

        REAL_T    celvol  , dx      , dy      , dz
        REAL_T    dx2dy   , dy2dx   , dx2dz   , dz2dx   , dy2dz   , dz2dy

        common / interface / celvol  , dx      , dy      , dz     ,
     &   dx2dy   , dy2dx   , dx2dz   , dz2dx   , dy2dz   , dz2dy

        integer i1,j1,k1,ii,iflag,iflaghard
        REAL_T  vcenter,lvlset(3,3,3),realnx,realny,realnz,minerr
        REAL_T  nxprm,nyprm,nzprm
        REAL_T  nvec(3),vol1,arclen
        REAL_T  dist2,x,y,z,xint,yint,zint,phi,dist(7)
        REAL_T  mindist,maxdist
        integer ngrow,ngrowx,ngrowy,ngrowz
        REAL_T fngrowx,fngrowy,fngrowz

        integer inbox(7),initflag,i2,j2,k2,linefound
        integer is,ie,js,je,ks,ke
        REAL_T  rval,r1,r2,facedists(3,3,3)
        REAL_T  holdlevel

        linefound=0

        is=domainlo(1)
        ie=domainhi(1)
        js=domainlo(2)
        je=domainhi(2)
        ks=domainlo(3)
        ke=domainhi(3)

        if ((dx.gt.dy).and.(dx.gt.dz)) then
         dxmax=dx
        else if (dy.gt.dz) then
         dxmax=dy
        else
         dxmax=dz
        endif

        do i1=1,3
        do j1=1,3
        do k1=1,3
          lvlset(i1,j1,k1)=work(ialt+i1-2,jalt+j1-2,kalt+k1-2,LEVELNORMAL)
        enddo
        enddo
        enddo
        call checkeasy(lvlset,iflag)
        if (iflag.eq.1) then
          vcenter=newstate(ialt,jalt,kalt,QVFRAC)
          call checkline(lvlset,iflaghard)

          if (iflaghard.eq.0) then
           if (lvlset(2,2,2).lt.zero) then
            vcenter=zero
           else if (lvlset(2,2,2).gt.zero) then
            vcenter=one
           endif
          endif

          if (vcenter.le.VOFTOL) then
           do i2=1,3
           do j2=1,3
           do k2=1,3
            facedists(i2,j2,k2)=-one
           enddo
           enddo
           enddo
          else if (vcenter.ge.one-VOFTOL) then
           do i2=1,3
           do j2=1,3
           do k2=1,3
            facedists(i2,j2,k2)=one
           enddo
           enddo
           enddo
          else

c  normal points from dark (F=1) to light (F=0)
           call normallvl(lvlset,dx, dy, dz, realnx, realny, realnz)
           nxprm = abs(realnx)
           nyprm = abs(realny)
           nzprm = abs(realnz)
           nvec(1)=nxprm
           nvec(2)=nyprm
           nvec(3)=nzprm
           vol1 = vcenter * celvol
           call voli(dx,dy,dz,vol1,nvec,arclen)
          
           dist2=sqrt(realnx**2+realny**2+realnz**2)
           if (dist2.gt.1.0E-15) then
            linefound=1

            realnx=-realnx/dist2
            realny=-realny/dist2
            realnz=-realnz/dist2
            if (realnx.gt.zero) then
             arclen=arclen-dx*realnx
            endif
            if (realny.gt.zero) then
             arclen=arclen-dy*realny
            endif
            if (realnz.gt.zero) then
             arclen=arclen-dz*realnz
            endif
           else
            print *,"dist2 < tol error"
            realnx=zero
            realny=zero
            realnz=zero
            arclen=sqrt(dx**2+dy**2+dz**2)*(vcenter-half)
           endif
c dist2.gt.zero?

           do i2=1,3
           do j2=1,3
           do k2=1,3
            phi=realnx*facepoints(i2,j2,k2,1)+
     &          realny*facepoints(i2,j2,k2,2)+
     &          realnz*facepoints(i2,j2,k2,3)+arclen
            facedists(i2,j2,k2)=phi
           enddo
           enddo 
           enddo 
          endif
c 0<vcenter<1?
          ngrow=spread+2
          fngrowx=(ngrow*dxmax)/dx
          ngrowx=int(fngrowx)
          fngrowy=(ngrow*dxmax)/dy
          ngrowy=int(fngrowy)
          fngrowz=(ngrow*dxmax)/dz
          ngrowz=int(fngrowz)

          do i1=-ngrowx,ngrowx
          do j1=-ngrowy,ngrowy
          do k1=-ngrowz,ngrowz

          if ((i1+i.ge.is).and.(i1+i.le.ie).and.
     &        (j1+j.ge.js).and.(j1+j.le.je).and.
     &        (k1+k.ge.ks).and.(k1+k.le.ke)) then
          if (volfrac(i+i1,j+j1,k+k1).gt.zero) then
           x=(i1+half)*dx
           y=(j1+half)*dy
           z=(k1+half)*dz
c          print *,"x,y,z"

           if (i1.lt.0) then
            i2=1
           else if (i1.eq.0) then
            i2=2
           else
            i2=3
           endif
           if (j1.lt.0) then
            j2=1
           else if (j1.eq.0) then
            j2=2
           else
            j2=3
           endif
           if (k1.lt.0) then
            k2=1
           else if (k1.eq.0) then
            k2=2
           else
            k2=3
           endif

           holdlevel=work(i+i1,j+j1,k+k1,LEVELNORMAL)
           if (facedists(i2,j2,k2)*holdlevel.gt.zero) then

            if (linefound.eq.1) then
             phi=realnx*x+realny*y+realnz*z+arclen
             xint=x-realnx*phi
             yint=y-realny*phi
             zint=z-realnz*phi
             call checkbox(xint,yint,zint,inbox(1),dx,dy,dz)
             if (inbox(1).eq.0) then
              call dist2d(x,y,z,realny,realnz,arclen,dist(2),inbox(2),
     &           dx,dy,dz)
              call dist2d(x-dx,y,z,realny,realnz,
     &           arclen+realnx*dx,dist(3),inbox(3),dx,dy,dz) 
              call dist2d(y,x,z,realnx,realnz,arclen,dist(4),inbox(4),
     &           dy,dx,dz)
              call dist2d(y-dy,x,z,realnx,realnz,
     &           arclen+realny*dy,dist(5),inbox(5),dy,dx,dz) 
              call dist2d(z,x,y,realnx,realny,arclen,dist(6),inbox(6),
     &           dz,dx,dy)
              call dist2d(z-dz,x,y,realnx,realny,
     &           arclen+realnz*dz,dist(7),inbox(7),dz,dx,dy) 
              initflag=0
              do ii=2,7
               if (inbox(ii).eq.1) then
                if (initflag.eq.0) then
                 mindist=dist(ii)
                 initflag=1
                else if (dist(ii).lt.mindist) then
                 mindist=dist(ii)
                endif
               endif
              enddo
              if (initflag.eq.0) then
               print *,"cannot find any distance!"
              endif
             else
              mindist=abs(phi)
             endif
             if (holdlevel.lt.zero) then
               mindist=-mindist
             endif

c !$OMP CRITICAL(dist)
             if (work(i+i1,j+j1,k+k1,LEVELFLAG).eq.zero) then
              newstate(i+i1,j+j1,k+k1,QLEVEL)=mindist
             else
              if (abs(mindist).lt.abs(newstate(i+i1,j+j1,k+k1,QLEVEL))) then
               newstate(i+i1,j+j1,k+k1,QLEVEL)=mindist
              endif
             endif
             work(i+i1,j+j1,k+k1,LEVELFLAG)=one
c !$OMP END CRITICAL(dist)
            endif
c linefound.eq.1
           else
             mindist=sqrt( (facepoints(i2,j2,k2,1)-x)**2 +
     &                     (facepoints(i2,j2,k2,2)-y)**2 +
     &                     (facepoints(i2,j2,k2,3)-z)**2 )
             if (holdlevel.lt.zero) then
              mindist=-mindist
             endif

c !$OMP CRITICAL(dist)
             if (work(i+i1,j+j1,k+k1,LEVELFLAG).eq.zero) then
              newstate(i+i1,j+j1,k+k1,QLEVEL)=mindist
             else
              if (abs(mindist).lt.abs(newstate(i+i1,j+j1,k+k1,QLEVEL))) then
               newstate(i+i1,j+j1,k+k1,QLEVEL)=mindist
              endif
             endif
             work(i+i1,j+j1,k+k1,LEVELFLAG)=one
c !$OMP END CRITICAL(dist)
           endif
          endif
c i1,j1,k1 in volfrac
          endif
c i1,j1,k1 in domain
          enddo
          enddo 
          enddo 
c i1,j1,k1
        endif 
c iflag.eq.1

        return
        end


        subroutine makedist(BL_BARG(domain),BL_BARG(domaingrow),
     &    BL_FARG(newstate),BL_FARG(work),
     &    BL_FARG(volfrac),dxlocal,bc)
        BL_BBOUNDS(domain)
        BL_BBOUNDS(domaingrow)
        BL_FBOUNDS(newstate)
        BL_FBOUNDS(work)
        BL_FBOUNDS(volfrac)
        BL_FARRAY1(volfrac)
        BL_FARRAY(newstate,QNUM)
        BL_FARRAY(work,WNUM)
 
        integer bc(2*BL_SPACEDIM)
        REAL_T dxlocal(3)

#include "probdata.H"

        REAL_T    celvol  , dx      , dy      , dz
        REAL_T    dx2dy   , dy2dx   , dx2dz   , dz2dx   , dy2dz   , dz2dy

        common / interface / celvol  , dx      , dy      , dz     ,
     &   dx2dy   , dy2dx   , dx2dz   , dz2dx   , dy2dz   , dz2dy

        integer i,j,k,i1,j1,k1,is,ie,js,je,ks,ke,ii,iflag,iflaghard
        integer ialt,jalt,kalt
        REAL_T  vcenter,lvlset(3,3,3),realnx,realny,realnz,minerr
        REAL_T  nxprm,nyprm,nzprm
        REAL_T  nvec(3),vol1,arclen
        REAL_T  dist2,x,y,z,xint,yint,zint,phi,dist(7)
        REAL_T  mindist,maxdist
        integer inbox(7),initflag,i2,j2,k2
        REAL_T  facepoints(3,3,3,3),facedists(3,3,3),dxmax,rval,r1,r2
        REAL_T  holdlevel

        dx=dxlocal(1)
        dy=dxlocal(2)
        dz=dxlocal(3)

        if ((dx.gt.dy).and.(dx.gt.dz)) then
         dxmax=dx
        else if (dy.gt.dz) then
         dxmax=dy
        else
         dxmax=dz
        endif

        print *,"in makedist dx,dy,dz,dxmax ",dx,dy,dz,dxmax
        celvol = dx * dy * dz

        dx2dy = dx * dx * dy
        dy2dx = dx * dy * dy

        dy2dz = dy * dy * dz
        dz2dy = dy * dz * dz

        dx2dz = dx * dx * dz
        dz2dx = dx * dz * dz

        call scalarbc(BL_FARG(newstate),bc,BL_BARG(domain),
     &   BL_BARG(domaingrow),QNUM,QLEVEL)
        call scalarextend(BL_FARG(newstate),BL_BARG(domain),
     &   BL_FARG(volfrac),QNUM,QLEVEL)
        call scalarbc(BL_FARG(newstate),bc,BL_BARG(domain),
     &   BL_BARG(domaingrow),QNUM,QVFRAC)

        do i2=1,3
        do j2=1,3
        do k2=1,3
         x=half*dx
         y=half*dy
         z=half*dz
         xint=((i2-2)+half)*dx 
         yint=((j2-2)+half)*dy 
         zint=((k2-2)+half)*dz 
         facepoints(i2,j2,k2,1)=half*(x+xint)
         facepoints(i2,j2,k2,2)=half*(y+yint)
         facepoints(i2,j2,k2,3)=half*(z+zint)
        enddo
        enddo
        enddo
  
        is=domainlo(1)
        ie=domainhi(1)
        js=domainlo(2)
        je=domainhi(2)
        ks=domainlo(3)
        ke=domainhi(3)


!$omp parallel do
        do i=domaingrowlo(1),domaingrowhi(1)
        do j=domaingrowlo(2),domaingrowhi(2)
        do k=domaingrowlo(3),domaingrowhi(3)
         work(i,j,k,LEVELFLAG)=zero
         work(i,j,k,LEVELNORMAL)=newstate(i,j,k,QLEVEL)
        enddo 
        enddo 
        enddo 

!$omp end parallel do

!$omp parallel do private(ialt,jalt,kalt)

        do i=is-spread-2,ie+spread+2
        do j=js-spread-2,je+spread+2
        do k=ks-spread-2,ke+spread+2
 
        call scalarlohibc(bc(1),bc(2),domainlo(1),domainhi(1),i,ialt)
        call scalarlohibc(bc(3),bc(4),domainlo(2),domainhi(2),j,jalt)
        call scalarlohibc(bc(5),bc(6),domainlo(3),domainhi(3),k,kalt)
 
        if (volfrac(ialt,jalt,kalt).gt.zero) then
         call distcheck(BL_BARG(domain),BL_BARG(domaingrow),
     &    BL_FARG(newstate),BL_FARG(work),
     &    BL_FARG(volfrac),bc,ialt,jalt,kalt,dxmax,facepoints,
     &    i,j,k)
        endif 
c i,j,k in eb domain
        enddo
        enddo
        enddo
c i,j,k

!$omp end parallel do

        mindist=-(float(spread)+three)*dxmax
        maxdist=(float(spread)+three)*dxmax

!$omp parallel do
        do i=is,ie
        do j=js,je
        do k=ks,ke
         if (volfrac(i,j,k).gt.zero) then
          if (work(i,j,k,LEVELFLAG).eq.zero) then
           if (work(i,j,k,LEVELNORMAL).lt.zero) then
            newstate(i,j,k,QLEVEL)=mindist
           else
            newstate(i,j,k,QLEVEL)=maxdist
           endif
          else
c          print *,"i,j,k,before,after ",i,j,k,work(i,j,k,LEVELNORMAL),
c    &       newstate(i,j,k,QLEVEL)
          endif
         endif
        enddo
        enddo
        enddo

!$omp end parallel do
        call scalarbc(BL_FARG(newstate),bc,BL_BARG(domain),
     &   BL_BARG(domaingrow),QNUM,QLEVEL)
        call scalarextend(BL_FARG(newstate),BL_BARG(domain),
     &   BL_FARG(volfrac),QNUM,QLEVEL)

        return
        end


        subroutine FORT_INITPARMS(
     &     liquidonlyf,rzf,probtypef,
     &     bcxlof,bcxhif,bcylof,bcyhif,bczlof,bczhif,
     &     verbosef,nxf,nyf,nzf,
     &     dwedgef,xdomainf,ydomainf,zdomainf,
     &     xblobf,yblobf,zblobf,rad1f,rad2f,speedf,
     &     adv_dirf,denairf,denwaterf,gravityf,tensionf,
     &     invisccoeff,spreadf,
     &     viscairf,viscwaterf)

        integer liquidonlyf,rzf,probtypef,spreadf
        integer bcxlof,bcxhif,bcylof,bcyhif,bczlof,bczhif 
        integer verbosef,nxf,nyf,nzf,adv_dirf
        REAL_T dwedgef,xdomainf,ydomainf,zdomainf,
     &         xblobf,yblobf,zblobf
        REAL_T rad1f,rad2f,speedf,denairf,denwaterf,gravityf,tensionf,
     &         invisccoeff,viscairf,viscwaterf

#include "probdata.H"

        liquidonly=liquidonlyf 
        print *,"liquidonly ",liquidonly
        rz=rzf
        probtype=probtypef
        bcxlo=bcxlof
        bcxhi=bcxhif
        bcylo=bcylof
        bcyhi=bcyhif
        bczlo=bczlof
        bczhi=bczhif
        verbose=verbosef
        nx=nxf
        ny=nyf
        nz=nzf
        dwedge=dwedgef
        xdomain=xdomainf
        ydomain=ydomainf
        zdomain=zdomainf
        xblob=xblobf
        yblob=yblobf
        zblob=zblobf
        rad1=rad1f
        rad2=rad2f
        speed=speedf
        adv_dir=adv_dirf
        denair=denairf
        denwater=denwaterf
        viscair=viscairf
        viscwater=viscwaterf
        gravity=gravityf
        tension=tensionf
        visccoeff=invisccoeff
        spread=spreadf

        return
        end

        REAL_T function heavyfn(phi,cutoff)
        REAL_T phi,cutoff

        if (phi.ge.cutoff) then
         heavyfn=one
        elseif (phi.le.-cutoff) then
         heavyfn=zero
        else
         heavyfn=phi/(two*cutoff)+sin(Pi*phi/cutoff)/(two*Pi)+half
        endif
        return
        end

        subroutine scalarlohibc(bclo,bchi,domlo,domhi,i,ii)
        integer bclo,bchi,domlo,domhi,i,ii

        if (i.lt.domlo) then
         if ((bclo.eq.REFLECT_EVEN).or.(bclo.eq.REFLECT_ODD)) then
          ii=domlo+(domlo-i-1)
         else if (bclo.eq.INT_DIR) then
          ii=domhi-(domlo-i-1) 
         else if ((bclo.eq.EXTRAP).or.(bclo.eq.EXT_DIR)) then
          ii=domlo
         else 
          print *,"bclo out of range in scalarlohibc"
         endif
        else if (i.gt.domhi) then
         if ((bchi.eq.REFLECT_EVEN).or.(bchi.eq.REFLECT_ODD)) then
          ii=domhi-(i-domhi-1)
         else if (bchi.eq.INT_DIR) then
          ii=domlo+(i-domhi-1) 
         else if ((bchi.eq.EXTRAP).or.(bchi.eq.EXT_DIR)) then
          ii=domhi
         else 
          print *,"bchi out of range in scalarlohibc"
         endif
        else 
         ii=i
        endif
 
        return
        end

        subroutine scalaredgelohibc(bclo,bchi,domlo,domhi,i,ii,factor)
        integer bclo,bchi,domlo,domhi,i,ii
        REAL_T factor

        factor=1.0
        if (i.lt.domlo) then
         if (bclo.eq.REFLECT_EVEN) then
          ii=domlo+(domlo-i)
          factor=-one
         else if (bclo.eq.INT_DIR) then
          ii=domhi-(domlo-i) 
         else if ((bclo.eq.EXTRAP).or.(bclo.eq.EXT_DIR)) then
          ii=domlo
         else 
          print *,"bclo out of range in scalaredgelohibc"
         endif
        else if (i.gt.domhi) then
         if (bchi.eq.REFLECT_EVEN) then
          ii=domhi-(i-domhi)
          factor=-one
         else if (bchi.eq.INT_DIR) then
          ii=domlo+(i-domhi) 
         else if ((bchi.eq.EXTRAP).or.(bchi.eq.EXT_DIR)) then
          ii=domhi
         else 
          print *,"bchi out of range in scalaredgelohibc"
         endif
        else
         ii=i
        endif
 
        return 
        end

        subroutine scalarextend(BL_FARG(scalar),BL_BARG(domain),
     &   BL_FARG(volfrac),ncomp,nval )
        integer ncomp,nval
        BL_BBOUNDS(domain)
        BL_FBOUNDS(scalar)
        BL_FBOUNDS(volfrac)
        BL_FARRAY(scalar,ncomp)
        BL_FARRAY1(volfrac)
        integer i,j,k,ii,jj,kk
        REAL_T hold,sumvol
  
!$omp parallel do private(hold,sumvol,ii,jj,kk,hold)
        do i=domainlo(1),domainhi(1)
        do j=domainlo(2),domainhi(2)
        do k=domainlo(3),domainhi(3)
         if (volfrac(i,j,k).eq.zero) then
          scalar(i,j,k,nval)=1.0E+10
          hold=zero
          sumvol=zero
          do ii=-1,1
          do jj=-1,1
          do kk=-1,1
           sumvol=sumvol+volfrac(i+ii,j+jj,k+kk)
           if (volfrac(i+ii,j+jj,k+kk).gt.zero) then
            hold=hold+scalar(i+ii,j+jj,k+kk,nval)*volfrac(i+ii,j+jj,k+kk)
           endif
          enddo
          enddo
          enddo
          if (sumvol.gt.zero) then
           scalar(i,j,k,nval)=hold/sumvol
          endif
         endif
        enddo 
        enddo 
        enddo 

!$omp end parallel do

        return
        end

        subroutine scalarbc(BL_FARG(scalar),bc,BL_BARG(domain),
     &   BL_BARG(domaingrow),ncomp,nval )
        integer ncomp,nval
        BL_BBOUNDS(domain)
        BL_BBOUNDS(domaingrow)
        BL_FBOUNDS(scalar)
        integer bc(2*BL_SPACEDIM)
        BL_FARRAY(scalar,ncomp)
        integer i,j,k,ii,jj,kk
  
        do i=domaingrowlo(1),domaingrowhi(1)
        do j=domaingrowlo(2),domaingrowhi(2)
        do k=domaingrowlo(3),domaingrowhi(3)
         call scalarlohibc(bc(1),bc(2),domainlo(1),domainhi(1),i,ii)
         call scalarlohibc(bc(3),bc(4),domainlo(2),domainhi(2),j,jj)
         call scalarlohibc(bc(5),bc(6),domainlo(3),domainhi(3),k,kk)
         scalar(i,j,k,nval)=scalar(ii,jj,kk,nval)
        enddo 
        enddo 
        enddo 

        return
        end

        subroutine scalaredgebc(BL_FARG(scalar),bc,BL_BARG(domain),
     &   BL_BARG(domaingrow) )
        BL_BBOUNDS(domain)
        BL_BBOUNDS(domaingrow)
        BL_FBOUNDS(scalar)
        integer bc(2*BL_SPACEDIM)
        BL_FARRAY(scalar,BL_SPACEDIM)
        integer i,j,k,ii,jj,kk
        REAL_T factor
  
        do i=domaingrowlo(1),domaingrowhi(1)
        do j=domaingrowlo(2),domaingrowhi(2)
        do k=domaingrowlo(3),domaingrowhi(3)
         call scalaredgelohibc(bc(1),bc(2),domainlo(1),domainhi(1)+1,
     &          i,ii,factor)
         call scalarlohibc(bc(3),bc(4),domainlo(2),domainhi(2),j,jj)
         call scalarlohibc(bc(5),bc(6),domainlo(3),domainhi(3),k,kk)
         scalar(i,j,k,1)=scalar(ii,jj,kk,1)

         call scalarlohibc(bc(1),bc(2),domainlo(1),domainhi(1),i,ii)
         call scalarlohibc(bc(5),bc(6),domainlo(3),domainhi(3),k,kk)
         call scalaredgelohibc(bc(3),bc(4),domainlo(2),domainhi(2)+1,
     &          j,jj,factor)
         scalar(i,j,k,2)=scalar(ii,jj,kk,2)

         call scalarlohibc(bc(1),bc(2),domainlo(1),domainhi(1),i,ii)
         call scalarlohibc(bc(3),bc(4),domainlo(2),domainhi(2),j,jj)
         call scalaredgelohibc(bc(5),bc(6),domainlo(3),domainhi(3)+1,
     &          k,kk,factor)
         scalar(i,j,k,3)=scalar(ii,jj,kk,3)

        enddo 
        enddo 
        enddo 

        return
        end

        subroutine velocitybc(BL_FARG(state),bc,BL_BARG(domain),
     &   BL_BARG(domaingrow) )
        BL_BBOUNDS(domain)
        BL_BBOUNDS(domaingrow)
        BL_FBOUNDS(state)
        integer bc(2*BL_SPACEDIM)
        BL_FARRAY(state,QNUM)
        integer i,j,k,ii,jj,kk
        REAL_T factor

#include "probdata.H"
 
        do k=domainlo(3),domainhi(3)
        do j=domainlo(2),domainhi(2)
         i=domainlo(1)
         if (bc(1).eq.EXT_DIR) then
          state(i,j,k,QVEL1)=speed
         else if (bc(1).eq.REFLECT_EVEN) then
          state(i,j,k,QVEL1)=zero
         endif
         i=domainhi(1)+1
         if (bc(2).eq.EXT_DIR) then
          state(i,j,k,QVEL1)=speed
         else if (bc(2).eq.REFLECT_EVEN) then
          state(i,j,k,QVEL1)=zero
         endif
        enddo
        enddo

        do k=domainlo(3),domainhi(3)
        do i=domainlo(1),domainhi(1)
         j=domainlo(2)
         if (bc(3).eq.EXT_DIR) then
          state(i,j,k,QVEL2)=speed
         else if (bc(3).eq.REFLECT_EVEN) then
          state(i,j,k,QVEL2)=zero
         endif
         j=domainhi(2)+1
         if (bc(4).eq.EXT_DIR) then
          state(i,j,k,QVEL2)=speed
         else if (bc(4).eq.REFLECT_EVEN) then
          state(i,j,k,QVEL2)=zero
         endif
        enddo
        enddo

        do j=domainlo(2),domainhi(2)
        do i=domainlo(1),domainhi(1)
         k=domainlo(3)
         if (bc(5).eq.EXT_DIR) then
          state(i,j,k,QVEL3)=speed
         else if (bc(5).eq.REFLECT_EVEN) then
          state(i,j,k,QVEL3)=zero
         endif
         k=domainhi(3)+1
         if (bc(6).eq.EXT_DIR) then
          state(i,j,k,QVEL3)=speed
         else if (bc(6).eq.REFLECT_EVEN) then
          state(i,j,k,QVEL3)=zero
         endif
        enddo
        enddo

        do i=domaingrowlo(1),domaingrowhi(1)
        do j=domaingrowlo(2),domaingrowhi(2)
        do k=domaingrowlo(3),domaingrowhi(3)
         factor=one
         call scalaredgelohibc(bc(1),bc(2),domainlo(1),domainhi(1)+1,
     &     i,ii,factor)
         call scalarlohibc(bc(3),bc(4),domainlo(2),domainhi(2),j,jj)
         call scalarlohibc(bc(5),bc(6),domainlo(3),domainhi(3),k,kk)
         state(i,j,k,QVEL1)=factor*state(ii,jj,kk,QVEL1)

         factor=one
         call scalarlohibc(bc(1),bc(2),domainlo(1),domainhi(1),i,ii)
         call scalaredgelohibc(bc(3),bc(4),domainlo(2),domainhi(2)+1,
     &     j,jj,factor)
         call scalarlohibc(bc(5),bc(6),domainlo(3),domainhi(3),k,kk)
         state(i,j,k,QVEL2)=factor*state(ii,jj,kk,QVEL2)

         factor=one
         call scalarlohibc(bc(1),bc(2),domainlo(1),domainhi(1),i,ii)
         call scalarlohibc(bc(3),bc(4),domainlo(2),domainhi(2),j,jj)
         call scalaredgelohibc(bc(5),bc(6),domainlo(3),domainhi(3)+1,
     &     k,kk,factor)
         state(i,j,k,QVEL3)=factor*state(ii,jj,kk,QVEL3)

        enddo 
        enddo 
        enddo 

        return
        end

        subroutine extraparea(phi1,phi2,area,dx,geomflag)
        REAL_T phi1,phi2,area,dx(3)
        integer geomflag

#include "probdata.H"

        REAL_T heavyfn,cutoff,dxmax

        if ((geomflag.eq.0).and.(spread.gt.0)) then
         dxmax=dx(1)
         if (dxmax.lt.dx(2)) then
          dxmax=dx(2)
         endif 
         if (dxmax.lt.dx(3)) then
          dxmax=dx(3)
         endif 
         cutoff=spread*dxmax
         area=heavyfn(0.5*(phi1+phi2),cutoff)
        else

        if ((phi1.gt.zero).and.(phi2.gt.zero)) then
          area=one
        else if ((phi1.le.zero).and.(phi2.le.zero)) then
          area=zero
        else if (phi1*phi2.eq.zero) then
          if (phi1+phi2.le.zero) then 
           area=zero
          else
           area=one
          endif
        else 
          area=phi1/(phi1-phi2)
          if (phi1.lt.zero) then
           area=one-area
          endif
        endif

        endif

        return 
        end

        subroutine extrapvolume(ax1,ax2,ay1,ay2,volume,geomflag)
        REAL_T ax1,ax2,ay1,ay2,volume
        REAL_T aax1,aax2,aay1,aay2
        integer geomflag

#include "probdata.H"

        if ((geomflag.eq.0).and.(spread.gt.0)) then
         volume=(ax1+ax2+ay1+ay2)/four
        else

        if (ax1.le.ax2) then
         aax1=ax2
         aax2=ax1
        else 
         aax1=ax1
         aax2=ax2
        endif
        if (ay1.le.ay2) then
         aay1=ay2
         aay2=ay1
        else 
         aay1=ay1
         aay2=ay2
        endif

        volume=(aax1-aax2)*(aay1-aay2)*half
        if ((aax2.gt.zero).and.(aay2.gt.zero)) then 
         volume=one-volume
        else if (aax2.gt.zero) then
         volume=volume+aax2
        else if (aay2.gt.zero) then
         volume=volume+aay2
        endif

        endif 

        return
        end

        subroutine initface(BL_FARG(areafrac),
     &     BL_FARG(levelnode),dx,dir,i,j,k,geomflag )
        BL_FBOUNDS(areafrac)
        BL_FBOUNDS(levelnode)
        BL_FARRAY(areafrac,BL_SPACEDIM)
        BL_FARRAY1(levelnode)
        REAL_T dx(3)
        integer dir,geomflag
        integer i,j,k,inode,jnode,knode,m,n
        REAL_T ax1,ax2,ay1,ay2,level(2,2)

#include "probdata.H"

        do m=0,1
        do n=0,1
         if (dir.eq.1) then
          inode=i
          jnode=j+m
          knode=k+n
         else if (dir.eq.2) then
          inode=i+m
          jnode=j
          knode=k+n
         else if (dir.eq.3) then   
          inode=i+m
          jnode=j+n
          knode=k
         else 
          print *,"dir out of range inode,jnode,knode"
         endif 
         level(m+1,n+1)=levelnode(inode,jnode,knode)
        enddo
        enddo
        call extraparea(level(1,1),level(2,1),ax1,dx,geomflag)
        call extraparea(level(1,1),level(1,2),ay1,dx,geomflag)
        call extraparea(level(2,1),level(2,2),ay2,dx,geomflag)
        call extraparea(level(1,2),level(2,2),ax2,dx,geomflag)
        call extrapvolume(ax1,ax2,ay1,ay2,areafrac(i,j,k,dir),geomflag)

        return
        end

        subroutine liquidarea(BL_FARG(areafrac),BL_FARG(volfrac),
     &     BL_FARG(levelnode),BL_BARG(domain),BL_BARG(domaingrow),
     &     dx,bc,ncomp,nval,geomflag )
        integer ncomp,nval
        BL_BBOUNDS(domain)
        BL_BBOUNDS(domaingrow)
        BL_FBOUNDS(areafrac)
        BL_FBOUNDS(volfrac)
        BL_FBOUNDS(levelnode)
        BL_FARRAY(areafrac,BL_SPACEDIM)
        BL_FARRAY(volfrac,ncomp)
        BL_FARRAY1(levelnode)
        integer bc(2*BL_SPACEDIM),geomflag
        REAL_T dx(3)
        integer dir
        integer i,j,k,ii,jj,kk

#include "probdata.H"

        do dir=1,BL_SPACEDIM
         call setindex(dir,ii,jj,kk)

!$omp parallel do
         do i=domainlo(1),domainhi(1)+ii
         do j=domainlo(2),domainhi(2)+jj
         do k=domainlo(3),domainhi(3)+kk
          call initface(BL_FARG(areafrac),BL_FARG(levelnode),
     &     dx,dir,i,j,k,geomflag)
         enddo
         enddo
         enddo

!$omp end parallel do
        enddo

!$omp parallel do
        do i=domainlo(1),domainhi(1)
        do j=domainlo(2),domainhi(2)
        do k=domainlo(3),domainhi(3)
         volfrac(i,j,k,nval)=(areafrac(i,j,k,1)+areafrac(i,j,k,2)+
     &      areafrac(i,j,k,3)+areafrac(i,j,k+1,3)+
     &      areafrac(i+1,j,k,1)+areafrac(i,j+1,k,2) )/(two*BL_SPACEDIM)
        enddo
        enddo
        enddo
!$omp end parallel do
  
        call scalaredgebc(BL_FARG(areafrac),bc,BL_BARG(domain),
     &    BL_BARG(domaingrow) ) 
        call scalarbc(BL_FARG(volfrac),bc,BL_BARG(domain),BL_BARG(domaingrow),
     &    ncomp,nval )

        return
        end

      subroutine geteblevel(x,y,z,dist)
      REAL_T x,y,z,dist

      real*8  eblevel(132,66,66)
      integer idxmax(3)
      real*8  xmin(3),xmax(3),dxgeom(3),distmin,distmax

      common / eblevel_var / eblevel,idxmax,xmin,xmax,
     &   distmin,distmax,dxgeom

      integer i,j,k

      i=int ( (x-xmin(1))/dxgeom(1) ) + 1
      j=int ( (y-xmin(2))/dxgeom(2) ) + 1
      k=int ( (z-xmin(3))/dxgeom(3) ) + 1
      if ((i.lt.1).or.(i.ge.idxmax(1)).or.
     &    (j.lt.1).or.(j.ge.idxmax(2)).or.
     &    (k.lt.1).or.(k.ge.idxmax(3))) then
       dist=distmax
      else
       xf=(x-(i-1)*dxgeom(1)-xmin(1))/dxgeom(1)
       yf=(y-(j-1)*dxgeom(2)-xmin(2))/dxgeom(2)
       zf=(z-(k-1)*dxgeom(3)-xmin(3))/dxgeom(3)
       dist=
     &  (one-xf)*(one-yf)*(one-zf)*eblevel(i,j,k)+
     &  (one-xf)*(one-yf)*(zf)*eblevel(i,j,k+1)+
     &  (one-xf)*(yf)*(one-zf)*eblevel(i,j+1,k)+
     &  (one-xf)*(yf)*(zf)*eblevel(i,j+1,k+1)+
     &  (xf)*(one-yf)*(one-zf)*eblevel(i+1,j,k)+
     &  (xf)*(one-yf)*(zf)*eblevel(i+1,j,k+1)+
     &  (xf)*(yf)*(one-zf)*eblevel(i+1,j+1,k)+
     &  (xf)*(yf)*(zf)*eblevel(i+1,j+1,k+1)
      endif

      return
      end

      subroutine readeblevel()

      character eblevel_file*20
      character formtype*20
      integer   error  
      
      real*8  eblevel(132,66,66)
      integer idxmax(3)
      real*8  xmin(3),xmax(3),dxgeom(3),distmin,distmax

      common / eblevel_var / eblevel,idxmax,xmin,xmax,
     &   distmin,distmax,dxgeom

      integer i,j,k
      
      eblevel_file = "eblevel.dat"
      formtype="formatted"
      print *,"opening ",eblevel_file
      OPEN(unit=13,file=eblevel_file,access='sequential',
     &   form=formtype,status='old')

      read(13,200) idxmax(1),idxmax(2),idxmax(3)
      read(13,250) dxgeom(1),dxgeom(2),dxgeom(3)
      read(13,250) xmin(1),xmin(2),xmin(3)
      read(13,250) xmax(1),xmax(2),xmax(3)
      print *,"imax,jmax,kmax is: ",idxmax(1),idxmax(2),idxmax(3)
      if ((idxmax(1).ge.132).or.(idxmax(2).ge.66).or.(idxmax(3).ge.66)) then
       print *,"out of bounds!"
       stop
      endif
      print *,"xmin,xmax,ymin,ymax,zmin,zmax"
      print *,xmin(1),xmax(1),xmin(2),xmax(2),xmin(3),xmax(3)
      print *,"dx,dy,dz ",dxgeom(1),dxgeom(2),dxgeom(3)
    
      distmin=zero
      distmax=zero 
      do i=1,idxmax(1)
      do j=1,idxmax(2)
      do k=1,idxmax(3)
       READ(13,100) eblevel(i,j,k)
       if (distmin.gt.eblevel(i,j,k)) then
         distmin=eblevel(i,j,k)
       endif
       if (distmax.lt.eblevel(i,j,k)) then
         distmax=eblevel(i,j,k)
       endif

      enddo
      enddo
      enddo

100   FORMAT(f12.7)
200   FORMAT(I10,I10,I10)
250   FORMAT(f20.10,f20.10,f20.10)
        
      close(13)

      print *,"distmin,distmax ",distmin,distmax

      return
      end

c unit are in meters

      subroutine boatparms(depth,waterdepth,height,length,botwidth,
     &   xback,yback,zback)
      REAL_T depth,waterdepth,height,length,botwidth,
     &       xback,yback,zback

#include "probdata.H"

      depth=-0.1
      waterdepth=0.0
      height=0.1
      length=1.0
      botwidth=0.1
      xback=1.0
      yback=0.1
      zback=waterdepth-depth

      return
      end


      subroutine boatdist(x,y,z,dist)
      REAL_T x,y,z,dist
      REAL_T depth,waterdepth,height,length,botwidth,
     &       xback,yback,zback

#include "probdata.H"

      call boatparms(depth,waterdepth,height,length,botwidth,
     &       xback,yback,zback) 
      dist=waterdepth-(z-zblob)
 
      return
      end
 
      subroutine boatgeom(x,y,z,dist)
      REAL_T x,y,z,dist
      REAL_T depth,waterdepth,height,length,botwidth,
     &       xback,yback,zback
      REAL_T xshift,yshift,zshift

#include "probdata.H"

      call geteblevel((x-xblob+half),(y-yblob),(z-zblob),dist)

      return
      end


        subroutine selectdist(dist,x,y,z)
        REAL_T dist,x,y,z,rval
        REAL_T HSB,NPT,NOD,NID,CHH,DIA,radjet

#include "probdata.H"

        if (probtype.eq.3) then
         dist=sqrt( (x-xblob)**2 + (y-yblob)**2 + (z-zblob)**2 ) -rad1
        else if (probtype.eq.6) then
         call boatdist(x,y,z,dist)
        else 
         print *,"probtype out of range"
        endif

        return
        end

        subroutine selectgeom(geomtype,eblevel,x,y,z)
        integer geomtype
        REAL_T eblevel,x,y,z,rval
        REAL_T HSB,NPT,NOD,NID,CHH,DIA,full,radjet,intercept,slope
 
#include "probdata.H"

        if (geomtype.eq.0) then
         eblevel=one 
        else if (geomtype.eq.3) then
         call boatgeom(x,y,z,eblevel)
        else
         print *,"geomtype out of range"
        endif

        return 
        end

        subroutine FORT_INITGEOMETRY(geomtype,bc,BL_BARG(domain),
     &    BL_BARG(domaingrow),
     &    dx,BL_FARG(eblevel),BL_FARG(levelnode),
     &    BL_FARG(volfrac),BL_FARG(areafrac),
     &    BL_FARG(volume),BL_FARG(area),BL_FARG(mask) )
        BL_BBOUNDS(domain)
        BL_BBOUNDS(domaingrow)
        BL_FBOUNDS(eblevel)
        BL_FBOUNDS(levelnode)
        BL_FBOUNDS(volfrac)
        BL_FBOUNDS(areafrac)
        BL_FBOUNDS(volume)
        BL_FBOUNDS(area)
        BL_FBOUNDS(mask)

        BL_FARRAY1(eblevel)
        BL_FARRAY1(levelnode)
        BL_FARRAY1(volfrac)
        BL_FARRAY1(volume)
       
        BL_FARRAY(areafrac,BL_SPACEDIM) 
        BL_FARRAY(area,BL_SPACEDIM) 

	integer mask(maskloi1:maskhii1,maskloi2:maskhii2,maskloi3:maskhii3)
        integer geomtype
        integer bc(2*BL_SPACEDIM)
        REAL_T dx(3)

#include "probdata.H"
   
        integer i,j,k,geomflag
        REAL_T x,y,z

        if (geomtype.eq.3) then
         call readeblevel()
        endif

        do i=domaingrowlo(1),domaingrowhi(1)
        do j=domaingrowlo(2),domaingrowhi(2)
        do k=domaingrowlo(3),domaingrowhi(3)
         area(i,j,k,1)=dx(2)*dx(3)
         area(i,j,k,2)=dx(1)*dx(3)
         area(i,j,k,3)=dx(1)*dx(2)
         volume(i,j,k)=dx(1)*dx(2)*dx(3)
         if ((rz.eq.1).and.(BL_SPACEDIM.eq.2)) then
          rcen=abs(dx(1)*(i+half))
          rhalf=abs(dx(1)*i)
          area(i,j,k,1)=dx(2)*two*Pi*rhalf
          area(i,j,k,2)=dx(1)*two*Pi*rcen
          volume(i,j,k)=dx(1)*dx(2)*two*Pi*rcen
         endif
         x=dx(1)*(i+half)
         y=dx(2)*(j+half)
         z=dx(3)*(k+half)
         call selectgeom(geomtype,eblevel(i,j,k),x,y,z)
        enddo
        enddo 
        enddo 

        do i=domaingrowlo(1)+1,domaingrowhi(1)
        do j=domaingrowlo(2)+1,domaingrowhi(2)
        do k=domaingrowlo(3)+1,domaingrowhi(3)
         x=dx(1)*i
         y=dx(2)*j
         z=dx(3)*k
         call selectgeom(geomtype,levelnode(i,j,k),x,y,z)
        enddo
        enddo
        enddo

        geomflag=1
        call liquidarea(BL_FARG(areafrac),BL_FARG(volfrac),
     &   BL_FARG(levelnode),BL_BARG(domain),
     &   BL_BARG(domaingrow),dx,bc,1,1,geomflag)

        do i=domaingrowlo(1),domaingrowhi(1)
        do j=domaingrowlo(2),domaingrowhi(2)
        do k=domaingrowlo(3),domaingrowhi(3)
         if (volfrac(i,j,k).eq.zero) then
          mask(i,j,k)=1
         endif
        enddo
        enddo
        enddo

        return
        end

        subroutine presslohi(bclo,bchi,domlo,domhi,i,ii,factor)
        integer bclo,bchi,domlo,domhi,i,ii
        REAL_T factor

        factor=one
        if (i.eq.domlo-1) then
         if (bclo.eq.INT_DIR) then
          ii=domhi
         else 
          ii=domlo
         endif
         if (bclo.eq.EXTRAP) then
          factor=-one
         endif
        else if (i.eq.domhi+1) then
         if (bchi.eq.INT_DIR) then
          ii=domlo
         else
          ii=domhi
         endif
         if (bchi.eq.EXTRAP) then
          factor=-one
         endif
        else
         print *,"i out of range in presslohi"
        endif

        return 
        end
 
        subroutine pressbc(BL_FARG(work),BL_BARG(domain),bc,source)
        BL_BBOUNDS(domain)
        BL_FBOUNDS(work)
        BL_FARRAY(work,WNUM)
        integer bc(2*BL_SPACEDIM)
        integer source
        integer i,j,k,is,ie,js,je,ks,ke,ii,jj,kk
        REAL_T factor
#include "probdata.H"

        is=domainlo(1)
        ie=domainhi(1)
        js=domainlo(2)
        je=domainhi(2)
        ks=domainlo(3)
        ke=domainhi(3)
   
        j=js-1
        call presslohi(bc(3),bc(4),js,je,j,jj,factor) 
        do k=ks,ke
        do i=is,ie
          work(i,j,k,source)=factor*work(i,jj,k,source)
        enddo
        enddo
c bottom face

        j=je+1
        call presslohi(bc(3),bc(4),js,je,j,jj,factor) 
        do k=ks,ke
        do i=is,ie
          work(i,j,k,source)=factor*work(i,jj,k,source)
        enddo
        enddo
c top face

        i=is-1
        call presslohi(bc(1),bc(2),is,ie,i,ii,factor) 
        do k=ks,ke
        do j=js,je
         work(i,j,k,source)=factor*work(ii,j,k,source)
        enddo
        enddo
c left face

        i=ie+1
        call presslohi(bc(1),bc(2),is,ie,i,ii,factor) 
        do k=ks,ke
        do j=js,je
         work(i,j,k,source)=factor*work(ii,j,k,source)
        enddo
        enddo
c right face



        k=ks-1
        call presslohi(bc(5),bc(6),ks,ke,k,kk,factor) 
        do i=is,ie
        do j=js,je
         work(i,j,k,source)=factor*work(i,j,kk,source)
        enddo
        enddo
c bot k face

        k=ke+1
        call presslohi(bc(5),bc(6),ks,ke,k,kk,factor) 
        do i=is,ie
        do j=js,je
         work(i,j,k,source)=factor*work(i,j,kk,source)
        enddo
        enddo
c top k face

        return
        end

        subroutine zapbc(BL_FARG(work),BL_BARG(domain),source)
        BL_BBOUNDS(domain)
        BL_FBOUNDS(work)
        BL_FARRAY(work,WNUM)
        integer source
        integer i,j,k,is,ie,js,je,ks,ke
#include "probdata.H"

        is=domainlo(1)
        ie=domainhi(1)
        js=domainlo(2)
        je=domainhi(2)
        ks=domainlo(3)
        ke=domainhi(3)
   
        do k=ks,ke
        do i=is,ie
         work(i,js-1,k,source)=zero
         work(i,je+1,k,source)=zero
        enddo
        enddo
        do k=ks,ke
        do j=js,je
         work(is-1,j,k,source)=zero
         work(ie+1,j,k,source)=zero
        enddo
        enddo
        do i=is,ie
        do j=js,je
         work(i,j,ks-1,source)=zero
         work(i,j,ke+1,source)=zero
        enddo
        enddo

        return
        end





        subroutine mg_project(BL_FARG(state),dx,bc,
     &   BL_BARG(domain),BL_BARG(domaingrow),
     &   BL_FARG(volfrac),BL_FARG(areafrac),
     &   BL_FARG(volume),BL_FARG(area),
     &   BL_FARG(work),BL_FARG(liquid_area),
     &   IMAX,JMAX,KMAX )
        BL_BBOUNDS(domain)
        BL_BBOUNDS(domaingrow)
        BL_FBOUNDS(state)
        BL_FBOUNDS(volfrac)
        BL_FBOUNDS(areafrac)
        BL_FBOUNDS(volume)
        BL_FBOUNDS(area)
        BL_FBOUNDS(liquid_area)
        BL_FBOUNDS(work)

        BL_FARRAY1(volfrac)
        BL_FARRAY1(volume)
        BL_FARRAY(areafrac,BL_SPACEDIM) 
        BL_FARRAY(area,BL_SPACEDIM) 
        BL_FARRAY(state,QNUM) 
        BL_FARRAY(liquid_area,BL_SPACEDIM)
        BL_FARRAY(work,WNUM)

        integer bc(2*BL_SPACEDIM)
        REAL_T dx(3)

#include "probdata.H"

        integer IMAX,JMAX,KMAX
        REAL_T, DIMENSION(KMAX,IMAX,JMAX)::POTL
        REAL_T, DIMENSION(KMAX,IMAX,JMAX)::PSOU
        REAL_T, DIMENSION(KMAX,IMAX,JMAX)::DENX
        REAL_T, DIMENSION(KMAX,IMAX,JMAX)::DENY
        REAL_T, DIMENSION(KMAX,IMAX,JMAX)::DENZ
C
C
        integer i,j,k,is,ie,js,je,ks,ke,it
        integer ILEV,LEVEL
        REAL_T norm,BOTTOL,TOPTOL

        print *,"starting projection...."

        is=domainlo(1)
        ie=domainhi(1)
        js=domainlo(2)
        je=domainhi(2)
        ks=domainlo(3)
        ke=domainhi(3)

!$omp parallel do
        do i=2,IMAX-1
        do j=2,JMAX-1
        do k=2,KMAX-1
         DENX(k,i,j)=work(i+is-2,j+js-2,k+ks-2,WCOEFFX)
         DENY(k,i,j)=work(i+is-2,j+js-2,k+ks-2,WCOEFFY)
         DENZ(k,i,j)=work(i+is-2,j+js-2,k+ks-2,WCOEFFZ)
         POTL(k,i,j)=work(i+is-2,j+js-2,k+ks-2,WSOLN)
         PSOU(k,i,j)=work(i+is-2,j+js-2,k+ks-2,WRHS)
        enddo
        enddo
        enddo
!$omp end parallel do
        if ((IMAX.lt.KMAX).and.(IMAX.lt.JMAX)) then
          minidx=IMAX
        else if (JMAX.lt.KMAX) then
          minidx=JMAX
        else
          minidx=KMAX
        endif
        minidx=minidx-2
        do LEVEL=1,32
C         if (minidx.lt.2) then
          if (minidx.lt.16) then
           goto 20
          endif
          minidx=minidx/2
        enddo
20      print *,"LEVEL in multigrid= ",LEVEL
        BOTTOL=1.0E-6
        TOPTOL=1.0E-4
        ILEV=1
        CALL HEAD_CG(ILEV,DENX,DENY,DENZ,POTL,PSOU,IMAX,JMAX,KMAX,BOTTOL,
     &    TOPTOL,LEVEL)

!$omp parallel do
        do i=2,IMAX-1
        do j=2,JMAX-1
        do k=2,KMAX-1
         work(i+is-2,j+js-2,k+ks-2,WSOLN)=POTL(k,i,j)
        enddo
        enddo
        enddo

!$omp end parallel do
        call pressbc(BL_FARG(work),BL_BARG(domain),bc,WSOLN)

        print *,"ending projection...."
        return
        end
 
        subroutine project(BL_FARG(state),dx,bc,
     &   BL_BARG(domain),BL_BARG(domaingrow),
     &   BL_FARG(volfrac),BL_FARG(areafrac),
     &   BL_FARG(volume),BL_FARG(area),
     &   BL_FARG(state_area),BL_FARG(work),BL_FARG(liquid_area) )
        BL_BBOUNDS(domain)
        BL_BBOUNDS(domaingrow)
        BL_FBOUNDS(state)
        BL_FBOUNDS(volfrac)
        BL_FBOUNDS(areafrac)
        BL_FBOUNDS(volume)
        BL_FBOUNDS(area)
        BL_FBOUNDS(state_area)
        BL_FBOUNDS(liquid_area)
        BL_FBOUNDS(work)

        BL_FARRAY1(volfrac)
        BL_FARRAY1(volume)
        BL_FARRAY(areafrac,BL_SPACEDIM) 
        BL_FARRAY(area,BL_SPACEDIM) 
        BL_FARRAY(state,QNUM) 
        BL_FARRAY(state_area,BL_SPACEDIM)
        BL_FARRAY(liquid_area,BL_SPACEDIM)
        BL_FARRAY(work,WNUM)

        integer bc(2*BL_SPACEDIM)
        REAL_T dx(3)

#include "probdata.H"

        integer i,j,k,is,ie,js,je,ks,ke,dir,side,it,singular,bcindex
        integer ii,jj,kk,IMAX,JMAX,KMAX
        REAL_T alpha,alpharr,alpharrpast,beta,denom,norm,testdot
        REAL_T sumrhs,sumtotal

        is=domainlo(1)
        ie=domainhi(1)
        js=domainlo(2)
        je=domainhi(2)
        ks=domainlo(3)
        ke=domainhi(3)

        call velocitybc(BL_FARG(state),bc,BL_BARG(domain),
     &    BL_BARG(domaingrow) )


!$omp parallel do
        do i=is,ie
        do j=js,je
        do k=ks,ke
          work(i,j,k,WRHS)=(
     &     areafrac(i+1,j,k,1)*area(i+1,j,k,1)*state(i+1,j,k,QVEL1)-
     &     areafrac(i,j,k,1)*area(i,j,k,1)*state(i,j,k,QVEL1)+
     &     areafrac(i,j+1,k,2)*area(i,j+1,k,2)*state(i,j+1,k,QVEL2)-
     &     areafrac(i,j,k,2)*area(i,j,k,2)*state(i,j,k,QVEL2)+
     &     areafrac(i,j,k+1,3)*area(i,j,k+1,3)*state(i,j,k+1,QVEL3)-
     &     areafrac(i,j,k,3)*area(i,j,k,3)*state(i,j,k,QVEL3) )

#if (0)
          print *,i,j,k,areafrac(i,j,k,1),areafrac(i+1,j,k,1),
     &        areafrac(i,j,k,2),areafrac(i,j+1,k,2),
     &        areafrac(i,j,k,3),areafrac(i,j,k+1,3)
          if ((volfrac(i,j,k).eq.zero).and.(1.eq.0)) then
           if (abs(areafrac(i,j,k,1))+abs(areafrac(i+1,j,k,1))+
     &         abs(areafrac(i,j,k,2))+abs(areafrac(i,j+1,k,2))+
     &         abs(areafrac(i,j,k,3))+abs(areafrac(i,j,k+1,3)).gt.zero) then
            print *,"SUM OF AREAS MUST BE ZERO IF VOLFRAC ZERO"
            print *,areafrac(i,j,k,1),areafrac(i+1,j,k,1),
     &        areafrac(i,j,k,2),areafrac(i,j+1,k,2),
     &        areafrac(i,j,k,3),areafrac(i,j,k+1,3)
           endif
          endif
          print *,"i,j,k,rhs ",i,j,k,work(i,j,k,WRHS)
#endif
        enddo
        enddo
        enddo

!$omp end parallel do

        singular=1
        do dir=1,BL_SPACEDIM
        do side=1,2
         bcindex=2*(dir-1)+side
         if (bc(bcindex).eq.EXTRAP) then
          singular=0
         endif
        enddo 
        enddo 
        print *,"singular= ",singular
        if (singular.eq.1) then
         sumrhs=zero
         sumtotal=zero
         do i=is,ie
         do j=js,je
         do k=ks,ke
          sumrhs=sumrhs+work(i,j,k,WRHS)
          sumtotal=sumtotal+volfrac(i,j,k)*volume(i,j,k)
         enddo
         enddo
         enddo
         print *,"sumrhs,sumtotal ",sumrhs,sumtotal
         do i=is,ie
         do j=js,je
         do k=ks,ke
          work(i,j,k,WRHS)=work(i,j,k,WRHS)-volfrac(i,j,k)*volume(i,j,k)*
     &      sumrhs/sumtotal
         enddo
         enddo
         enddo
        endif

        do dir=1,BL_SPACEDIM
         call setindex(dir,ii,jj,kk)
 
!$omp parallel do
         do i=is,ie+ii
         do j=js,je+jj
         do k=ks,ke+kk
          work(i,j,k,WCOEFFX+dir-1)=zero
          if (areafrac(i,j,k,dir).gt.zero) then
            work(i,j,k,WCOEFFX+dir-1)=areafrac(i,j,k,dir)*area(i,j,k,dir)*
     &         state_area(i,j,k,dir)/dx(dir)
#if (0) 
            print *,"dir,i,j,k,sarea,area,afrac ",
     &       dir,i,j,k,state_area(i,j,k,dir),
     &       area(i,j,k,dir),areafrac(i,j,k,dir)
#endif
          endif
         enddo 
         enddo 
         enddo 

!$omp end parallel do

        enddo 
        IMAX=ie-is+1+2
        JMAX=je-js+1+2
        KMAX=ke-ks+1+2

        call mg_project(BL_FARG(state),dx,bc,
     &   BL_BARG(domain),BL_BARG(domaingrow),
     &   BL_FARG(volfrac),BL_FARG(areafrac),
     &   BL_FARG(volume),BL_FARG(area),
     &   BL_FARG(work),BL_FARG(liquid_area),
     &   IMAX,JMAX,KMAX )

        call pressbc(BL_FARG(work),BL_BARG(domain),bc,WSOLN)

#if (0)
        do i=is-1,ie+1 
        do j=js-1,je+1 
        do k=ks-1,ke+1 
          print *,"press:i,j,k,press ",i,j,k,work(i,j,k,WSOLN)
        enddo
        enddo
        enddo
#endif
        do dir=1,BL_SPACEDIM
         call setindex(dir,ii,jj,kk)


!$omp parallel do

         do i=is,ie+ii
         do j=js,je+jj
         do k=ks,ke+kk
          if (areafrac(i,j,k,dir).eq.zero) then
           state(i,j,k,QVEL1+dir-1)=zero
          else
c          print *,"before:dir,i,j,k,vel ",dir,i,j,k,state(i,j,k,QVEL1+dir-1)
           state(i,j,k,QVEL1+dir-1)=state(i,j,k,QVEL1+dir-1)-
     &        (work(i,j,k,WSOLN)-work(i-ii,j-jj,k-kk,WSOLN))*
     &        state_area(i,j,k,dir)/dx(dir)
c          print *,"after:dir,i,j,k,vel ",dir,i,j,k,state(i,j,k,QVEL1+dir-1)
          endif
         enddo
         enddo
         enddo


!$omp end parallel do
        enddo

        call velocitybc(BL_FARG(state),bc,BL_BARG(domain),
     &    BL_BARG(domaingrow) )

#if (0)
        call testdiv(BL_FARG(state),bc,BL_BARG(domain),BL_BARG(domaingrow),
     &    BL_FARG(volfrac),BL_FARG(areafrac),BL_FARG(volume),BL_FARG(area),
     &    BL_FARG(work),WVOLFRACP) 
#endif

        return
        end

        subroutine FORT_GETDT(BL_FARG(state),shrink,dxmin,
     &    cfl,dt,BL_BARG(domain),BL_BARG(domaingrow),bc)
        REAL_T shrink,dxmin,cfl,dt
        BL_BBOUNDS(domain)
        BL_BBOUNDS(domaingrow)
        BL_FBOUNDS(state)
        BL_FARRAY(state,QNUM) 
        integer bc(2*BL_SPACEDIM)

#include "probdata.H"
   
        integer i,j,k,ii,jj,kk,dir
        REAL_T umax(BL_SPACEDIM),umaxmax,utension,kair,kwater,kmax
        REAL_T uviscous

        call velocitybc(BL_FARG(state),bc,BL_BARG(domain),
     &   BL_BARG(domaingrow))

        umaxmax=zero
        do dir=1,BL_SPACEDIM
         call setindex(dir,ii,jj,kk)

         umax(dir)=zero
         do i=domainlo(1),domainhi(1)+ii
         do j=domainlo(2),domainhi(2)+jj
         do k=domainlo(3),domainhi(3)+kk
          if (abs(state(i,j,k,QVEL1+dir-1)).gt.umax(dir)) then
           umax(dir)=abs(state(i,j,k,QVEL1+dir-1))
          endif 
         enddo
         enddo
         enddo
         print *,"dir,umax ",dir,umax(dir)
         if (umax(dir).gt.umaxmax) then
          umaxmax=umax(dir)
         endif
        enddo

c       print *,"tension,denair,denwater,dxmin,utension"
c       print *,tension,denair,denwater,dxmin,utension
        utension=sqrt(eight*Pi*tension/(dxmin*(denair+denwater)))
        if (utension.gt.umaxmax) then
         umaxmax=utension
        endif
        kair=visccoeff*viscair/denair
        kwater=visccoeff*viscwater/denwater
        if (kair.lt.kwater) then
         kmax=kwater
        else
         kmax=kair
        endif
        uviscous=kmax/dxmin
        if (uviscous.gt.umaxmax) then
         umaxmax=uviscous
        endif
        if (umaxmax.eq.zero) then
         print *,"umaxmax is zero setting to 1"
         umaxmax=one
        endif
        print *,"uvisc,utension,umaxmax ",uviscous,utension,umaxmax

        dt=shrink*cfl*dxmin/umaxmax
        print *,"AFTER GETDT dt,shrink,cfl,dxmin,umaxmax ",
     &    dt,shrink,cfl,dxmin,umaxmax
        return
        end 

        subroutine testdiv(BL_FARG(state),bc,BL_BARG(domain),
     &    BL_BARG(domaingrow),BL_FARG(volfrac),BL_FARG(areafrac),
     &    BL_FARG(volume),BL_FARG(area),BL_FARG(vfrac),vcomp)

        BL_BBOUNDS(domain)
        BL_BBOUNDS(domaingrow)
        BL_FBOUNDS(state)
        BL_FBOUNDS(vfrac)
        BL_FBOUNDS(volfrac)
        BL_FBOUNDS(areafrac)
        BL_FBOUNDS(volume)
        BL_FBOUNDS(area)

        BL_FARRAY1(volfrac)
        BL_FARRAY1(volume)
        BL_FARRAY(areafrac,BL_SPACEDIM) 
        BL_FARRAY(area,BL_SPACEDIM) 
        BL_FARRAY(state,QNUM) 
        integer vcomp
        BL_FARRAY(vfrac,vcomp) 

        integer bc(2*BL_SPACEDIM)

#include "probdata.H"

        integer i,j,k,is,ie,js,je,ks,ke
        REAL_T divtest,sumdivtest

        is=domainlo(1)
        ie=domainhi(1)
        js=domainlo(2)
        je=domainhi(2)
        ks=domainlo(3)
        ke=domainhi(3)

        sumdivtest=zero
c       print *,"liquidonly ",liquidonly
        do i=is,ie
        do j=js,je
        do k=ks,ke
         if (volfrac(i,j,k).gt.zero) then
          divtest=(
     &     areafrac(i+1,j,k,1)*area(i+1,j,k,1)*state(i+1,j,k,QVEL1)-
     &     areafrac(i,j,k,1)*area(i,j,k,1)*state(i,j,k,QVEL1)+
     &     areafrac(i,j+1,k,2)*area(i,j+1,k,2)*state(i,j+1,k,QVEL2)-
     &     areafrac(i,j,k,2)*area(i,j,k,2)*state(i,j,k,QVEL2)+
     &     areafrac(i,j,k+1,3)*area(i,j,k+1,3)*state(i,j,k+1,QVEL3)-
     &     areafrac(i,j,k,3)*area(i,j,k,3)*state(i,j,k,QVEL3) )

          if ((liquidonly.eq.1).and.(vfrac(i,j,k,vcomp).eq.zero)) then
           divtest=zero
          endif
          sumdivtest=sumdivtest+abs(divtest)
         endif
        enddo
        enddo
        enddo
        print *,"sumdivtest ",sumdivtest

        return
        end

        subroutine vof(
     &   BL_FARG(newstate),BL_FARG(halfstate),dt,
     &   BL_FARG(areafrac),BL_FARG(area),BL_FARG(work),
     &   i,j,k,ii,jj,kk,dir )
        BL_FBOUNDS(newstate)
        BL_FBOUNDS(halfstate)
        BL_FBOUNDS(areafrac)
        BL_FBOUNDS(area)
        BL_FBOUNDS(work)

        BL_FARRAY(areafrac,BL_SPACEDIM) 
        BL_FARRAY(area,BL_SPACEDIM) 
        BL_FARRAY(newstate,QNUM) 
        BL_FARRAY(halfstate,QNUM) 
        BL_FARRAY(work,WNUM)

        REAL_T dt
        integer i,j,k,ii,jj,kk,dir

#include "probdata.H"

        integer iii,jjj,kkk
        integer i1,j1,k1,itemp,itemp1
        REAL_T du,vflx,vcenter,slope,a
        REAL_T edgevel
        REAL_T lvlset(3,3,3),nvec(3),minerr,vleft

        REAL_T    celvol  , dx      , dy      , dz
        REAL_T    dx2dy   , dy2dx   , dx2dz   , dz2dx   , dy2dz   , dz2dy

        common / interface / celvol  , dx      , dy      , dz     ,
     &   dx2dy   , dy2dx   , dx2dz   , dz2dx   , dy2dz   , dz2dy

        edgevel=halfstate(i,j,k,QVEL1+dir-1)
        du=abs(edgevel*dt)
        if (du.gt.zero) then 
         if (edgevel.le.zero) then
          vcenter=newstate(i,j,k,QVFRAC)
         else
          vcenter=newstate(i-ii,j-jj,k-kk,QVFRAC)
         endif
         if (vcenter.ge.one-VOFTOL) then
          work(i,j,k,WFLUXVFRACX+dir-1)=one
         else if (vcenter.le.VOFTOL) then
          work(i,j,k,WFLUXVFRACX+dir-1)=zero
         else
          do i1=1,3
          do j1=1,3
          do k1=1,3
           if (edgevel.le.zero) then
            lvlset(i1,j1,k1)=newstate(i+i1-2,j+j1-2,k+k1-2,QLEVEL)
           else
            lvlset(4-i1,4-j1,4-k1)=
     &       newstate(i+i1-2-ii,j+j1-2-jj,k+k1-2-kk,QLEVEL)
           endif
          enddo
          enddo
          enddo
          call level3d(lvlset,vcenter,du,vleft,minerr,nvec,
     &       dir,area(i,j,k,dir))
          vflx=du*area(i,j,k,dir)
          work(i,j,k,WFLUXVFRACX+dir-1)=vleft/vflx
         endif
        else
         work(i,j,k,WFLUXVFRACX+dir-1)=zero
        endif

        return
        end


        subroutine clsvof(BL_FARG(state),
     &   BL_FARG(newstate),BL_FARG(halfstate),dxlocal,dt,bc,
     &   BL_BARG(domain),BL_BARG(domaingrow),
     &   BL_FARG(volfrac),BL_FARG(areafrac),
     &   BL_FARG(volume),BL_FARG(area),BL_FARG(work),plot_n )
        BL_BBOUNDS(domain)
        BL_BBOUNDS(domaingrow)
        BL_FBOUNDS(state)
        BL_FBOUNDS(newstate)
        BL_FBOUNDS(halfstate)
        BL_FBOUNDS(volfrac)
        BL_FBOUNDS(areafrac)
        BL_FBOUNDS(volume)
        BL_FBOUNDS(area)
        BL_FBOUNDS(work)

        BL_FARRAY1(volfrac)
        BL_FARRAY1(volume)
        BL_FARRAY(areafrac,BL_SPACEDIM) 
        BL_FARRAY(area,BL_SPACEDIM) 
        BL_FARRAY(state,QNUM) 
        BL_FARRAY(newstate,QNUM) 
        BL_FARRAY(halfstate,QNUM) 
        BL_FARRAY(work,WNUM)

        integer bc(2*BL_SPACEDIM),plot_n
        REAL_T dxlocal(3)
        REAL_T dt,t

#include "probdata.H"

        integer i,j,k,is,ie,js,je,ks,ke,ii,jj,kk,iii,jjj,kkk
        integer i1,j1,k1,itemp,itemp1,absdir,dir,voltot
        REAL_T divtest,maxdivtest,du,vflx,vcenter,slope,a
        REAL_T edgevel,macplus,macminus,uxterm,fluxdiff
        REAL_T dxmax

        REAL_T    celvol  , dx      , dy      , dz
        REAL_T    dx2dy   , dy2dx   , dx2dz   , dz2dx   , dy2dz   , dz2dy

        common / interface / celvol  , dx      , dy      , dz     ,
     &   dx2dy   , dy2dx   , dx2dz   , dz2dx   , dy2dz   , dz2dy

        dx=dxlocal(1)
        dy=dxlocal(2)
        dz=dxlocal(3)
        if ((dx.gt.dy).and.(dx.gt.dz)) then
         dxmax=dx
        else if (dy.gt.dz) then
         dxmax=dy
        else
         dxmax=dz
        endif

        celvol = dx*dy*dz

        dx2dy = dx * dx * dy
        dy2dx = dx * dy * dy

        dy2dz = dy * dy * dz
        dz2dy = dy * dz * dz

        dx2dz = dx * dx * dz
        dz2dx = dx * dz * dz

        is=domainlo(1)
        ie=domainhi(1)
        js=domainlo(2)
        je=domainhi(2)
        ks=domainlo(3)
        ke=domainhi(3)

#if (0)
        call testdiv(BL_FARG(halfstate),bc,BL_BARG(domain),
     &   BL_BARG(domaingrow),BL_FARG(volfrac),BL_FARG(areafrac),
     &   BL_FARG(volume),BL_FARG(area),BL_FARG(newstate),QVFRAC)
#endif

!$omp parallel do
        do i=is,ie
        do j=js,je
        do k=ks,ke
         work(i,j,k,WTEMPF)=zero
         work(i,j,k,WTEMPL)=zero
        enddo
        enddo
        enddo
!$omp end parallel do

        do absdir=1,BL_SPACEDIM
         print *,"bcs ",bc(1),bc(2),bc(3),bc(4),bc(5),bc(6)
         call scalarbc(BL_FARG(newstate),bc,BL_BARG(domain),
     &     BL_BARG(domaingrow),QNUM,QLEVEL)
         call scalarbc(BL_FARG(newstate),bc,BL_BARG(domain),
     &     BL_BARG(domaingrow),QNUM,QVFRAC)
         call scalarextend(BL_FARG(newstate),BL_BARG(domain),
     &     BL_FARG(volfrac),QNUM,QLEVEL)

         itemp=plot_n+absdir-1
         itemp1=itemp/BL_SPACEDIM
         dir=itemp-BL_SPACEDIM*itemp1
         dir=dir+1
         print *,"in clsvof, dir=",dir

         call setindex(dir,ii,jj,kk) 

c level set update first


!$omp parallel do private(edgevel,slope,a)
	 do i = is,ie+ii
 	 do j = js,je+jj
 	 do k = ks,ke+kk
          if (areafrac(i,j,k,dir).eq.zero) then
           work(i,j,k,WFLUXLEVELX+dir-1)=zero
           work(i,j,k,WFLUXVFRACX+dir-1)=zero
          else
           edgevel=halfstate(i,j,k,QVEL1+dir-1)
           if (edgevel.le.zero) then
            slope=(newstate(i+ii,j+jj,k+kk,QLEVEL)-
     &             newstate(i-ii,j-jj,k-kk,QLEVEL))*half
            a=-1.0-(dt/dxlocal(dir))*edgevel
            work(i,j,k,WFLUXLEVELX+dir-1)=newstate(i,j,k,QLEVEL)+
     &        half*slope*a
           else
            slope=(newstate(i,j,k,QLEVEL)-
     &             newstate(i-2*ii,j-2*jj,k-2*kk,QLEVEL))*half
            a=1.0-(dt/dxlocal(dir))*edgevel
            work(i,j,k,WFLUXLEVELX+dir-1)=newstate(i-ii,j-jj,k-kk,QLEVEL)+
     &        half*slope*a
           endif
           call vof(BL_FARG(newstate),BL_FARG(halfstate),dt,
     &       BL_FARG(areafrac),
     &       BL_FARG(area),BL_FARG(work),i,j,k,ii,jj,kk,dir )
          endif
         enddo
         enddo
         enddo
!$omp end parallel do

!$omp parallel do private(macplus,macminus,uxterm,fluxdiff)
         do i=is,ie
         do j=js,je
         do k=ks,ke
          if (volfrac(i,j,k).gt.zero) then
           macplus=halfstate(i+ii,j+jj,k+kk,QVEL1+dir-1)*
     &      area(i+ii,j+jj,k+kk,dir)*areafrac(i+ii,j+jj,k+kk,dir)
           macminus=halfstate(i,j,k,QVEL1+dir-1)*area(i,j,k,dir)*
     &       areafrac(i,j,k,dir)
           uxterm=(macplus-macminus)/volume(i,j,k)
           fluxdiff=dt*(macplus*work(i+ii,j+jj,k+kk,WFLUXVFRACX+dir-1)-
     &          macminus*work(i,j,k,WFLUXVFRACX+dir-1))/volume(i,j,k)
           newstate(i,j,k,QVFRAC)=(newstate(i,j,k,QVFRAC)-fluxdiff)/
     &        (one-dt*uxterm)
           work(i,j,k,WTEMPF)=work(i,j,k,WTEMPF)+
     &       dt*uxterm*newstate(i,j,k,QVFRAC)

           fluxdiff=dt*(macplus*work(i+ii,j+jj,k+kk,WFLUXLEVELX+dir-1)-
     &          macminus*work(i,j,k,WFLUXLEVELX+dir-1))/volume(i,j,k)
           newstate(i,j,k,QLEVEL)=(newstate(i,j,k,QLEVEL)-fluxdiff)/
     &        (one-dt*uxterm)
           work(i,j,k,WTEMPL)=work(i,j,k,WTEMPL)+
     &        dt*uxterm*newstate(i,j,k,QLEVEL)

           if (absdir.eq.BL_SPACEDIM) then
            newstate(i,j,k,QVFRAC)=newstate(i,j,k,QVFRAC)-work(i,j,k,WTEMPF)
            newstate(i,j,k,QLEVEL)=newstate(i,j,k,QLEVEL)-work(i,j,k,WTEMPL)
           endif
          endif
         enddo
         enddo
         enddo
!$omp end parallel do

        enddo
c absdir

!$omp parallel do
        do i=is,ie
        do j=js,je
        do k=ks,ke
         if (volfrac(i,j,k).gt.zero) then
          if ((newstate(i,j,k,QLEVEL).gt.dxmax).or.
     &        (newstate(i,j,k,QVFRAC).gt.one)) then
           newstate(i,j,k,QVFRAC)=one
          else if ((newstate(i,j,k,QLEVEL).lt.-dxmax).or.
     &             (newstate(i,j,k,QVFRAC).lt.zero)) then
           newstate(i,j,k,QVFRAC)=zero
          endif
         endif 
        enddo
        enddo
        enddo
!$omp end parallel do

        return
        end

        subroutine viscpoint(BL_FARG(newstate),
     &   BL_FARG(halfstate),dx,dt,bc,
     &   BL_BARG(domain),BL_BARG(domaingrow),
     &   BL_FARG(volfrac),BL_FARG(areafrac),
     &   BL_FARG(volume),BL_FARG(area),BL_FARG(liquid_area),
     &   BL_FARG(state_area),
     &   i,j,k,dir )
        BL_BBOUNDS(domain)
        BL_BBOUNDS(domaingrow)
        BL_FBOUNDS(halfstate)
        BL_FBOUNDS(newstate)
        BL_FBOUNDS(volfrac)
        BL_FBOUNDS(areafrac)
        BL_FBOUNDS(volume)
        BL_FBOUNDS(area)
        BL_FBOUNDS(liquid_area)
        BL_FBOUNDS(state_area)

        BL_FARRAY1(volfrac)
        BL_FARRAY1(volume)
        BL_FARRAY(areafrac,BL_SPACEDIM) 
        BL_FARRAY(area,BL_SPACEDIM) 
        BL_FARRAY(halfstate,QNUM) 
        BL_FARRAY(newstate,QNUM) 
        BL_FARRAY(liquid_area,BL_SPACEDIM)
        BL_FARRAY(state_area,BL_SPACEDIM)

        integer bc(2*BL_SPACEDIM)
        REAL_T dx(3)
        REAL_T dt
        integer dir,dir1,side

#include "probdata.H"

        integer i,j,k,ii,jj,kk,iii,jjj,kkk
        integer i1,j1,k1
        REAL_T vel(BL_SPACEDIM,3,3,3),coeff(BL_SPACEDIM,3,3,3)
        REAL_T tensor(BL_SPACEDIM,2)
        REAL_T testheavy,rval,testvolume,viscsum,hoopfactor

        call setindex(dir,ii,jj,kk)
        if (areafrac(i,j,k,dir)*area(i,j,k,dir).gt.zero) then
         do i1=-1,1
         do j1=-1,1
         do k1=-1,1
          vel(dir,i1+2,j1+2,k1+2)=halfstate(i+i1,j+j1,k+k1,QVEL1+dir-1)
          testheavy=liquid_area(i+i1,j+j1,k+k1,dir)
          coeff(dir,i1+2,j1+2,k1+2)=area(i+i1,j+j1,k+k1,dir)*
     &     (viscwater*testheavy+viscair*(one-testheavy))
          do dir1=1,BL_SPACEDIM
           if (dir1.ne.dir) then
            call setindex(dir1,iii,jjj,kkk)
            vel(dir1,i1+2,j1+2,k1+2)=(halfstate(i+i1,j+j1,k+k1,QVEL1+dir1-1)+
     &       halfstate(i-ii+i1,j-jj+j1,k-kk+k1,QVEL1+dir1-1)+
     &       halfstate(i+iii+i1,j+jjj+j1,k+kkk+k1,QVEL1+dir1-1)+
     &       halfstate(i+iii-ii+i1,j+jjj-jj+j1,k+kkk-kk+k1,QVEL1+dir1-1) )/four
            coeff(dir1,i1+2,j1+2,k1+2)=(
     &        area(i+i1,j+j1,k+k1,dir1)+area(i-ii+i1,j-jj+j1,k-kk+k1,dir1)+
     &        area(i+iii+i1,j+jjj+j1,k+kkk+k1,dir1)+
     &        area(i+iii-ii+i1,j+jjj-jj+j1,k+kkk-kk+k1,dir1) )/four
            testheavy=(liquid_area(i+i1,j+j1,k+k1,dir1)+
     &        liquid_area(i-ii+i1,j-jj+j1,k-kk+k1,dir1)+
     &        liquid_area(i+iii+i1,j+jjj+j1,k+kkk+k1,dir1)+
     &        liquid_area(i+iii-ii+i1,j+jjj-jj+j1,k+kkk-kk+k1,dir1) )/four
            coeff(dir1,i1+2,j1+2,k1+2)=coeff(dir1,i1+2,j1+2,k1+2)*
     &          (viscwater*testheavy+viscair*(one-testheavy))
           endif
c dir1.ne.dir
          enddo
c dir1
         enddo
         enddo
         enddo
c i1,j1,k1
         do side=0,1
         do dir1=1,BL_SPACEDIM
          call setindex(dir1,iii,jjj,kkk)
          i1=2+(side-1)*iii
          j1=2+(side-1)*jjj
          k1=2+(side-1)*kkk
          if (dir1.eq.dir) then
           tensor(dir1,side+1)=
     &        (coeff(dir1,i1,j1,k1)+coeff(dir1,i1+iii,j1+jjj,k1+kkk))*
     &        (vel(dir,i1+iii,j1+jjj,k1+kkk)-vel(dir,i1,j1,k1))/dx(dir1)
          else
           tensor(dir1,side+1)=
     &      (coeff(dir1,i1,j1,k1)+coeff(dir1,i1+iii,j1+jjj,k1+kkk))*half*
     &      ( (vel(dir1,i1+ii,j1+jj,k1+kk)-
     &         vel(dir1,i1-ii,j1-jj,k1-kk)+
     &         vel(dir1,i1+ii+iii,j1+jj+jjj,k1+kk+kkk)-
     &         vel(dir1,i1-ii+iii,j1-jj+jjj,k1-kk+kkk) )/(four*dx(dir))+
     &        (vel(dir,i1+iii,j1+jjj,k1+kkk)-vel(dir,i1,j1,k1))/dx(dir1) )
          endif
         enddo
         enddo
c dir1,side

         testvolume=(volume(i,j,k)+volume(i-ii,j-jj,k-kk))*half
         testheavy=liquid_area(i,j,k,dir)
         viscsum=zero
         do dir1=1,BL_SPACEDIM
          viscsum=viscsum+dt*visccoeff*state_area(i,j,k,dir)*
     &     (tensor(dir1,2)-tensor(dir1,1))/testvolume
         enddo
         newstate(i,j,k,QVEL1+dir-1)=newstate(i,j,k,QVEL1+dir-1)+viscsum
         
        endif
c areas >0
        return
        end


        subroutine makevisc(BL_FARG(newstate),
     &   BL_FARG(halfstate),dx,dt,bc,
     &   BL_BARG(domain),BL_BARG(domaingrow),
     &   BL_FARG(volfrac),BL_FARG(areafrac),
     &   BL_FARG(volume),BL_FARG(area),BL_FARG(liquid_area),
     &   BL_FARG(state_area),BL_FARG(work) )
        BL_BBOUNDS(domain)
        BL_BBOUNDS(domaingrow)
        BL_FBOUNDS(halfstate)
        BL_FBOUNDS(newstate)
        BL_FBOUNDS(volfrac)
        BL_FBOUNDS(areafrac)
        BL_FBOUNDS(volume)
        BL_FBOUNDS(area)
        BL_FBOUNDS(liquid_area)
        BL_FBOUNDS(state_area)
        BL_FBOUNDS(work)

        BL_FARRAY1(volfrac)
        BL_FARRAY1(volume)
        BL_FARRAY(areafrac,BL_SPACEDIM) 
        BL_FARRAY(area,BL_SPACEDIM) 
        BL_FARRAY(halfstate,QNUM) 
        BL_FARRAY(newstate,QNUM) 
        BL_FARRAY(liquid_area,BL_SPACEDIM)
        BL_FARRAY(state_area,BL_SPACEDIM)
        BL_FARRAY(work,WNUM)

        integer bc(2*BL_SPACEDIM)
        REAL_T dx(3)
        REAL_T dt
        integer dir,dir1

#include "probdata.H"

        integer i,j,k,is,ie,js,je,ks,ke,ii,jj,kk,iii,jjj,kkk
        integer i1,j1,k1
        REAL_T x,y,z

        print *,"in makevisc,dt ",dt

        is=domainlo(1)
        ie=domainhi(1)
        js=domainlo(2)
        je=domainhi(2)
        ks=domainlo(3)
        ke=domainhi(3)
#if (0)
        dt=one
        visccoeff=one
        viscair=one
        viscwater=one
        denair=one
        denwater=one
 
        do dir=1,BL_SPACEDIM
         print *,"initializing viscous debug data dir=",dir
         call setindex(dir,ii,jj,kk)
         do i=is,ie+ii
         do j=js,je+jj 
         do k=ks,ke+kk
          x=(i+half)*dx(1)-half*ii*dx(1) 
          y=(j+half)*dx(2)-half*jj*dx(2) 
          z=(k+half)*dx(3)-half*kk*dx(3) 
          newstate(i,j,k,QVEL1+dir-1)=zero
          halfstate(i,j,k,QVEL1+dir-1)=(one+ii)*x*x+(one+jj)*y*y+
     &     (one+kk)*z*z
          liquid_area(i,j,k,dir)=one 
          state_area(i,j,k,dir)=one 
          areafrac(i,j,k,dir)=one
         enddo
         enddo
         enddo
        enddo
        
        do dir=1,BL_SPACEDIM
         print *,"testing viscous debug data dir=",dir
         call setindex(dir,ii,jj,kk)
         do i=is+2,ie-2+ii
         do j=js+2,je-2+jj
         do k=ks+2,ke-2+kk
          x=(i+half)*dx(1)-half*ii*dx(1)
          y=(j+half)*dx(2)-half*jj*dx(2)
          z=(k+half)*dx(3)-half*kk*dx(3) 
          call viscpoint(BL_FARG(newstate),
     &       BL_FARG(halfstate),dx,dt,bc,
     &       BL_BARG(domain),BL_BARG(domaingrow),
     &       BL_FARG(volfrac),BL_FARG(areafrac),
     &       BL_FARG(volume),BL_FARG(area),BL_FARG(liquid_area),
     &       BL_FARG(state_area),
     &       i,j,k,dir )
          print *,"expect,comp ",12.0,newstate(i,j,k,QVEL1+dir-1)
         enddo
         enddo
         enddo
        enddo
#endif    
        if (visccoeff.gt.zero) then
         do dir=1,BL_SPACEDIM
          call setindex(dir,ii,jj,kk)
!$omp parallel do
          do i=is,ie+ii
          do j=js,je+jj 
          do k=ks,ke+kk 
           call viscpoint(BL_FARG(newstate),
     &       BL_FARG(halfstate),dx,dt,bc,
     &       BL_BARG(domain),BL_BARG(domaingrow),
     &       BL_FARG(volfrac),BL_FARG(areafrac),
     &       BL_FARG(volume),BL_FARG(area),BL_FARG(liquid_area),
     &       BL_FARG(state_area),
     &       i,j,k,dir )

          enddo 
          enddo 
          enddo 
c i,j,k
!$omp end parallel do

         enddo 
c dir
        endif
c visccoeff>0
        return
        end



c state contains data for curvature...
c newstate contains the velocity that will be updated.
        subroutine makeforce(BL_FARG(state),
     &   BL_FARG(newstate),dx,dt,initial_step,bc,
     &   BL_BARG(domain),BL_BARG(domaingrow),
     &   BL_FARG(eblevel),BL_FARG(levelnode),
     &   BL_FARG(volfrac),BL_FARG(areafrac),
     &   BL_FARG(volume),BL_FARG(area),
     &   prob_lo,prob_hi,plot_n,nvar,t,
     &   BL_FARG(liquid_area),BL_FARG(state_area),
     &   BL_FARG(work) )
        BL_BBOUNDS(domain)
        BL_BBOUNDS(domaingrow)
        BL_FBOUNDS(state)
        BL_FBOUNDS(newstate)
        BL_FBOUNDS(volfrac)
        BL_FBOUNDS(areafrac)
        BL_FBOUNDS(volume)
        BL_FBOUNDS(area)
        BL_FBOUNDS(liquid_area)
        BL_FBOUNDS(state_area)
        BL_FBOUNDS(eblevel)
        BL_FBOUNDS(levelnode)
        BL_FBOUNDS(work)

        BL_FARRAY1(volfrac)
        BL_FARRAY1(volume)
        BL_FARRAY(areafrac,BL_SPACEDIM) 
        BL_FARRAY(area,BL_SPACEDIM) 
        BL_FARRAY(state,QNUM) 
        BL_FARRAY(newstate,QNUM) 
        BL_FARRAY(liquid_area,BL_SPACEDIM)
        BL_FARRAY(state_area,BL_SPACEDIM)
        BL_FARRAY1(eblevel)
        BL_FARRAY1(levelnode)
        BL_FARRAY(work,WNUM)

        integer bc(2*BL_SPACEDIM)
        REAL_T dx(3),prob_lo(BL_SPACEDIM),prob_hi(BL_SPACEDIM)
        REAL_T dt,t
        integer initial_step,plot_n,nvar
        integer dir,dir1
        REAL_T dx1(2,2,2),dy1(2,2,2),dz1(2,2,2),norm(2,2,2),dxx,dyy,dzz
        REAL_T curv,gradh,gravforce,heaterlen,pterm,x,y,z

#include "probdata.H"

        integer i,j,k,is,ie,js,je,ks,ke,ii,jj,kk,iii,jjj,kkk,geomflag,curvcnt

        print *,"in surface tension,t,dt,n ",t,dt,plot_n

        is=domainlo(1)
        ie=domainhi(1)
        js=domainlo(2)
        je=domainhi(2)
        ks=domainlo(3)
        ke=domainhi(3)

        call scalarbc(BL_FARG(state),bc,BL_BARG(domain),
     &    BL_BARG(domaingrow),QNUM,QLEVEL)
        call scalarbc(BL_FARG(state),bc,BL_BARG(domain),
     &     BL_BARG(domaingrow),QNUM,QVFRAC)
        call scalarextend(BL_FARG(state),BL_BARG(domain),
     &     BL_FARG(volfrac),QNUM,QLEVEL)

!$omp parallel do
        do i=is,ie+1
        do j=js,je+1
        do k=ks,ke+1
          levelnode(i,j,k)=(state(i,j,k,QLEVEL)+state(i-1,j,k,QLEVEL)+
     &      state(i,j-1,k,QLEVEL)+state(i-1,j-1,k,QLEVEL)+
     &      state(i,j,k-1,QLEVEL)+state(i-1,j,k-1,QLEVEL)+
     &      state(i,j-1,k-1,QLEVEL)+state(i-1,j-1,k-1,QLEVEL) )/eight
c         print *,"lnode:i,j,k,lnode ",i,j,k,levelnode(i,j,k)
        enddo
        enddo
        enddo

!$omp end parallel do
        geomflag=0
        call liquidarea(BL_FARG(liquid_area),BL_FARG(work),
     &    BL_FARG(levelnode),BL_BARG(domain),BL_BARG(domaingrow),
     &    dx,bc,WNUM,WVOLFRACP,geomflag)


        gravforce=-dt*abs(gravity)
        do dir=1,BL_SPACEDIM
        call setindex(dir,ii,jj,kk)


!$omp parallel do
        do i=is,ie+ii
        do j=js,je+jj 
        do k=ks,ke+kk

         if (areafrac(i,j,k,dir).gt.zero) then
          state_area(i,j,k,dir)=(one/denwater)*liquid_area(i,j,k,dir)+
     &       (one/denair)*(one-liquid_area(i,j,k,dir))

          if (dir.eq.BL_SPACEDIM) then
           newstate(i,j,k,QVEL1+dir-1)=newstate(i,j,k,QVEL1+dir-1)+gravforce
          endif      
         else
          newstate(i,j,k,QVEL1+dir-1)=zero
         endif

        enddo
        enddo
        enddo

!$omp end parallel do

        enddo
c dir
        return
        end

        subroutine FORT_MAKETRACER(BL_FARG(state),BL_FARG(tracer),
     &    BL_BARG(domain),BL_BARG(domaingrow),
     &    BL_FARG(eblevel),BL_FARG(volfrac),dx,
     &    BL_FARG(work),bc)
        BL_FBOUNDS(state)
        BL_FBOUNDS(tracer)
        BL_FBOUNDS(eblevel)
        BL_FBOUNDS(volfrac)
        BL_FBOUNDS(work)
        BL_FARRAY(state,QNUM) 
        BL_FARRAY(work,WNUM) 
        BL_FARRAY1(tracer)
        BL_FARRAY1(eblevel)
        BL_FARRAY1(volfrac)
        BL_BBOUNDS(domain)
        BL_BBOUNDS(domaingrow)
        REAL_T dx(3),heavyfn,cutoff
        integer bc(2*BL_SPACEDIM)

#include "probdata.H"

        REAL_T, DIMENSION(:,:,:), ALLOCATABLE::LVLSET

        integer i,j,k,is,ie,js,je,ks,ke
        integer IMAX,JMAX,KMAX,ifree,ireverse
        integer iter,ii,jj,kk,changeflag
        REAL_T sumdata,sumvol

        is=domainlo(1)
        ie=domainhi(1)
        js=domainlo(2)
        je=domainhi(2)
        ks=domainlo(3)
        ke=domainhi(3)

        IMAX=ie-is+1
        JMAX=je-js+1
        KMAX=ke-ks+2
        ALLOCATE(LVLSET(IMAX,JMAX,KMAX))

        cutoff=dx(1)*10

!$omp parallel do 
        do i=is,ie
        do j=js,je
        do k=ks,ke
         tracer(i,j,k)=state(i,j,k,QVFRAC)
         if (probtype.eq.6) then
          tracer(i,j,k)=heavyfn(eblevel(i,j,k),cutoff)
         endif
         LVLSET(i-is+1,j-js+1,k-ks+1)=eblevel(i,j,k)
        enddo
        enddo
        enddo
!$omp end parallel do 
        LVLSET(:,:,KMAX)=zero
        ifree=0
        ireverse=1
        call MARCHING(LVLSET,IMAX,JMAX,KMAX,dx(1),dx(2),dx(3),ifree,ireverse)

        call scalarbc(BL_FARG(state),bc,BL_BARG(domain),
     &   BL_BARG(domaingrow),QNUM,QLEVEL)
        call scalarextend(BL_FARG(state),BL_BARG(domain),
     &   BL_FARG(volfrac),QNUM,QLEVEL)
!$omp parallel do 
        do i=is-1,ie+1
        do j=js-1,je+1
        do k=ks-1,ke+1
         work(i,j,k,WTEMPL)=zero
         if (volfrac(i,j,k).gt.zero) then
          work(i,j,k,WTEMPL)=one
         endif
        enddo
        enddo
        enddo
!$omp end parallel do 

        do iter=1,20
!$omp parallel do 
         do i=is,ie
         do j=js,je
         do k=ks,ke
          work(i,j,k,WTEMPF)=zero
         enddo
         enddo
         enddo
!$omp end parallel do 

!$omp parallel do private(sumdata,sumvol,ii,jj,kk)
         do i=is,ie
         do j=js,je
         do k=ks,ke
          if (volfrac(i,j,k).eq.zero) then
           sumdata=zero
           sumvol=zero
           do ii=-1,1
           do jj=-1,1
           do kk=-1,1
            sumvol=sumvol+work(i+ii,j+jj,k+kk,WTEMPL)
            if (work(i+ii,j+jj,k+kk,WTEMPL).eq.one) then
             sumdata=sumdata+state(i+ii,j+jj,k+kk,QLEVEL)
            endif
           enddo
           enddo
           enddo
           if (sumvol.gt.zero) then
            work(i,j,k,WTEMPF)=one
            state(i,j,k,QLEVEL)=sumdata/sumvol
           endif
          endif
         enddo
         enddo
         enddo
!$omp end parallel do
         changeflag=0
         do i=is,ie
         do j=js,je
         do k=ks,ke
          if (work(i,j,k,WTEMPF).eq.one) then
           work(i,j,k,WTEMPL)=one
           changeflag=1
          endif
         enddo
         enddo
         enddo
         if ((changeflag.eq.0).and.(1.eq.0)) then
          goto 15
         endif
        enddo
15      print *,"number of extends ",iter

        do i=is,ie
        do j=js,je
        do k=ks,ke
         LVLSET(i-is+1,j-js+1,k-ks+1)=state(i,j,k,QLEVEL)
        enddo
        enddo
        enddo
        LVLSET(:,:,KMAX)=zero
        ifree=1
        ireverse=0
        call MARCHING(LVLSET,IMAX,JMAX,KMAX,dx(1),dx(2),dx(3),ifree,ireverse)

        DEALLOCATE(LVLSET)

        return
        end

        subroutine FORT_ADVANCE(BL_FARG(state),
     &   BL_FARG(newstate),BL_FARG(halfstate),dx,dt,initial_step,bc,
     &   BL_BARG(domain),BL_BARG(domaingrow),
     &   BL_FARG(eblevel),BL_FARG(levelnode),
     &   BL_FARG(volfrac),BL_FARG(areafrac),
     &   BL_FARG(volume),BL_FARG(area),
     &   prob_lo,prob_hi,plot_n,nvar,t,
     &   BL_FARG(liquid_area),BL_FARG(state_area),
     &   BL_FARG(work) )
        BL_BBOUNDS(domain)
        BL_BBOUNDS(domaingrow)
        BL_FBOUNDS(state)
        BL_FBOUNDS(newstate)
        BL_FBOUNDS(halfstate)
        BL_FBOUNDS(volfrac)
        BL_FBOUNDS(areafrac)
        BL_FBOUNDS(volume)
        BL_FBOUNDS(area)
        BL_FBOUNDS(liquid_area)
        BL_FBOUNDS(state_area)
        BL_FBOUNDS(eblevel)
        BL_FBOUNDS(levelnode)
        BL_FBOUNDS(work)

        BL_FARRAY1(volfrac)
        BL_FARRAY1(volume)
        BL_FARRAY(areafrac,BL_SPACEDIM) 
        BL_FARRAY(area,BL_SPACEDIM) 
        BL_FARRAY(state,QNUM) 
        BL_FARRAY(newstate,QNUM) 
        BL_FARRAY(halfstate,QNUM) 
        BL_FARRAY(liquid_area,BL_SPACEDIM)
        BL_FARRAY(state_area,BL_SPACEDIM)
        BL_FARRAY1(eblevel)
        BL_FARRAY1(levelnode)
        BL_FARRAY(work,WNUM)

        integer bc(2*BL_SPACEDIM)
        REAL_T dx(3),prob_lo(BL_SPACEDIM),prob_hi(BL_SPACEDIM)
        REAL_T dt,t
        integer initial_step,plot_n,nvar
        integer dir,dir1,rkloop,rkorder
        REAL_T voldark,vollight,areatotal

#include "probdata.H"

        integer i,j,k,is,ie,js,je,ks,ke,ii,jj,kk,iii,jjj,kkk,geomflag
        REAL_T advect(BL_SPACEDIM),aa,bb,cc,unlo,unhi,utlo,uthi

        print *,"in FORT_ADVANCE,t,dt,n ",t,dt,plot_n

        is=domainlo(1)
        ie=domainhi(1)
        js=domainlo(2)
        je=domainhi(2)
        ks=domainlo(3)
        ke=domainhi(3)

        rkorder=2
        do rkloop=1,rkorder

         print *,"starting nonlinear terms...."
         call velocitybc(BL_FARG(halfstate),bc,BL_BARG(domain),
     &     BL_BARG(domaingrow) )

         do dir=1,BL_SPACEDIM
           call setindex(dir,ii,jj,kk)

!$omp parallel do private(advect,dir1,areatotal,iii,jjj,kkk)
           do i=is,ie+ii
           do j=js,je+jj 
           do k=ks,ke+kk
            if (areafrac(i,j,k,dir).gt.zero) then
             advect(dir)=halfstate(i,j,k,QVEL1+dir-1)
             do dir1=1,BL_SPACEDIM
              if (dir1.ne.dir) then
               call setindex(dir1,iii,jjj,kkk)
               areatotal=areafrac(i,j,k,dir1)+
     &          areafrac(i-ii,j-jj,k-kk,dir1)+
     &          areafrac(i+iii,j+jjj,k+kkk,dir1)+
     &          areafrac(i+iii-ii,j+jjj-jj,k+kkk-kk,dir1) 
               if (areatotal.eq.zero) then
                advect(dir1)=zero
               else
                advect(dir1)=(halfstate(i,j,k,QVEL1+dir1-1)+
     &            halfstate(i-ii,j-jj,k-kk,QVEL1+dir1-1)+
     &            halfstate(i+iii,j+jjj,k+kkk,QVEL1+dir1-1)+
     &            halfstate(i+iii-ii,j+jjj-jj,k+kkk-kk,QVEL1+dir1-1) )/four
               endif
              endif
             enddo 
             if (1.eq.1) then
              call nonlinear(i,j,k,advect,BL_FARG(newstate),
     &         BL_FARG(halfstate),QVEL1+dir-1,dx,dt,BL_FARG(areafrac) )
             endif
            endif
           enddo
           enddo
           enddo
!$omp end parallel do
         enddo
c dir
  
         print *,"done with nonlinear terms..."

c routine clsvof advects QLEVEL,QVFRAC,does redistribution step
c clsvof uses halfstate for velocity, state and newstate as initial data.
c new advected quantities in newstate
         print *,"starting clsvof..."
         call clsvof(BL_FARG(state),BL_FARG(newstate),BL_FARG(halfstate),
     &    dx,dt,bc,BL_BARG(domain),BL_BARG(domaingrow),BL_FARG(volfrac),
     &    BL_FARG(areafrac),BL_FARG(volume),BL_FARG(area),BL_FARG(work),
     &    plot_n )
         print *,"done with clsvof..."

         print *,"starting makeforce..."
         call makeforce(BL_FARG(newstate),BL_FARG(newstate),
     &     dx,dt,initial_step,bc,
     &     BL_BARG(domain),BL_BARG(domaingrow),
     &     BL_FARG(eblevel),BL_FARG(levelnode),
     &     BL_FARG(volfrac),BL_FARG(areafrac),
     &     BL_FARG(volume),BL_FARG(area),
     &     prob_lo,prob_hi,plot_n,nvar,t,
     &     BL_FARG(liquid_area),BL_FARG(state_area),
     &     BL_FARG(work) )
         print *,"done with makeforce..."

         print *,"starting makevisc..."
         call makevisc(BL_FARG(newstate),BL_FARG(halfstate),
     &      dx,dt,bc,BL_BARG(domain),BL_BARG(domaingrow),
     &      BL_FARG(volfrac),BL_FARG(areafrac),
     &      BL_FARG(volume),BL_FARG(area),BL_FARG(liquid_area),
     &      BL_FARG(state_area) )
         print *,"done with makevisc..."

         call project(BL_FARG(newstate),dx,bc,BL_BARG(domain),
     &     BL_BARG(domaingrow),BL_FARG(volfrac),BL_FARG(areafrac),
     &     BL_FARG(volume),BL_FARG(area),BL_FARG(state_area),BL_FARG(work),
     &     BL_FARG(liquid_area) )

         if (rkloop.eq.rkorder) then
          call scalarbc(BL_FARG(newstate),bc,BL_BARG(domain),
     &     BL_BARG(domaingrow),QNUM,QLEVEL)
          call scalarbc(BL_FARG(newstate),bc,BL_BARG(domain),
     &     BL_BARG(domaingrow),QNUM,QVFRAC)
          call scalarextend(BL_FARG(newstate),BL_BARG(domain),
     &     BL_FARG(volfrac),QNUM,QLEVEL)
         endif

         if (rkloop.lt.rkorder) then     

!$omp parallel do
          do i=domaingrowlo(1),domaingrowhi(1)
          do j=domaingrowlo(2),domaingrowhi(2)
          do k=domaingrowlo(3),domaingrowhi(3)
          do dir=1,QNUM
           halfstate(i,j,k,dir)=(state(i,j,k,dir)+newstate(i,j,k,dir))*half
           newstate(i,j,k,dir)=state(i,j,k,dir) 
          enddo
          enddo
          enddo
          enddo

!$omp end parallel do
         else
!$omp parallel do
          do i=domaingrowlo(1),domaingrowhi(1)
          do j=domaingrowlo(2),domaingrowhi(2)
          do k=domaingrowlo(3),domaingrowhi(3)
          do dir=1,QNUM
           halfstate(i,j,k,dir)=(state(i,j,k,dir)+newstate(i,j,k,dir))*half
           state(i,j,k,dir)=newstate(i,j,k,dir) 
          enddo
          enddo
          enddo
          enddo
!$omp end parallel do
         endif

        enddo
c rkloop
        print *,"starting makedist.... "
        if (1.eq.1) then
         call makedist(BL_BARG(domain),BL_BARG(domaingrow),
     &    BL_FARG(newstate),BL_FARG(work),
     &    BL_FARG(volfrac),dx,bc)

!$omp parallel do
         do i=domaingrowlo(1),domaingrowhi(1)
         do j=domaingrowlo(2),domaingrowhi(2)
         do k=domaingrowlo(3),domaingrowhi(3)
          state(i,j,k,QLEVEL)=newstate(i,j,k,QLEVEL)
         enddo
         enddo
         enddo

!$omp end parallel do
        endif
        print *,"done with  makedist.... "
        voldark=zero
        vollight=zero
        do i=is,ie 
        do j=js,je 
        do k=ks,ke
         voldark=voldark+volume(i,j,k)*volfrac(i,j,k)*newstate(i,j,k,QVFRAC)
         vollight=vollight+
     &     volume(i,j,k)*volfrac(i,j,k)*(one-newstate(i,j,k,QVFRAC))
        enddo
        enddo
        enddo
        print *,"voldark,vollight ",voldark,vollight

        return
        end

        subroutine FORT_PROBINIT(BL_FARG(state),dx,bc,
     &   BL_BARG(domain),BL_BARG(domaingrow),
     &   BL_FARG(volfrac),BL_FARG(areafrac),
     &   BL_FARG(volume),BL_FARG(area),BL_FARG(levelnode),
     &   BL_FARG(liquid_area),BL_FARG(state_area),
     &   prob_lo,prob_hi,BL_FARG(work) )
        BL_BBOUNDS(domain)
        BL_BBOUNDS(domaingrow)
        BL_FBOUNDS(state)
        BL_FBOUNDS(volfrac)
        BL_FBOUNDS(areafrac)
        BL_FBOUNDS(volume)
        BL_FBOUNDS(area)
        BL_FBOUNDS(liquid_area)
        BL_FBOUNDS(state_area)
        BL_FBOUNDS(levelnode)
        BL_FBOUNDS(work)

        BL_FARRAY1(volfrac)
        BL_FARRAY1(volume)
        BL_FARRAY(areafrac,BL_SPACEDIM) 
        BL_FARRAY(area,BL_SPACEDIM) 
        BL_FARRAY(state,QNUM) 
        BL_FARRAY(liquid_area,BL_SPACEDIM)
        BL_FARRAY(state_area,BL_SPACEDIM)
        BL_FARRAY1(levelnode)
        BL_FARRAY(work,WNUM)

        integer bc(2*BL_SPACEDIM)
        REAL_T dx(3),prob_lo(BL_SPACEDIM),prob_hi(BL_SPACEDIM)
        integer dir

#include "probdata.H"
   
        integer i,j,k,geomflag
        REAL_T x,y,z
        REAL_T depth,waterdepth,height,length,botwidth,
     &         xback,yback,zback


        if (probtype.eq.6) then
         call boatparms(depth,waterdepth,height,length,botwidth,
     &       xback,yback,zback)
         print *,"boat: depth,waterdepth,ht,ln,wd,xb,yb,zb ",depth,
     &       waterdepth,height,length,botwidth,xback,yback,zback
         print *,"boat speed: speed= ",speed
        else if (probtype.ne.3) then
         print *,"ONLY DO SHIP WAVE PROBLEMS WITH THIS CODE!!!!"
         stop
        endif

        do i=domainlo(1),domainhi(1)+1
        do j=domainlo(2),domainhi(2)
        do k=domainlo(3),domainhi(3) 
         x=i*dx(1)
         y=(j+half)*dx(2)
         z=(k+half)*dx(3)
         state(i,j,k,QVEL1)=zero
         if (probtype.eq.1) then
          if (y.ge.0.5) then
           state(i,j,k,QVEL1)=tanh((0.75-y)*30.0)
          else 
           state(i,j,k,QVEL1)=tanh((y-0.25)*30.0)
          endif
         else if (probtype.eq.2) then
          state(i,j,k,QVEL1)=-sin(Pi*x)*sin(Pi*x)*sin(two*Pi*y)
         else if ((probtype.eq.4).or.(probtype.eq.6)) then
          if ((adv_dir.eq.1).or.(adv_dir.eq.BL_SPACEDIM+1)) then
           state(i,j,k,QVEL1)=speed
          endif
         endif
        enddo
        enddo
        enddo
    
        do i=domainlo(1),domainhi(1)
        do j=domainlo(2),domainhi(2)+1
        do k=domainlo(3),domainhi(3) 
         x=(i+half)*dx(1)
         y=j*dx(2)
         z=(k+half)*dx(3)
         state(i,j,k,QVEL2)=zero
         if (probtype.eq.1) then
          state(i,j,k,QVEL2)=0.05*sin(two*Pi*x)
         else if (probtype.eq.2) then
          state(i,j,k,QVEL2)=sin(Pi*y)*sin(Pi*y)*sin(two*Pi*x)
         else if ((probtype.eq.4).or.(probtype.eq.6)) then
          if ((adv_dir.eq.2).or.(adv_dir.eq.BL_SPACEDIM+1)) then
           state(i,j,k,QVEL2)=speed
          endif
         endif
        enddo
        enddo
        enddo

        do i=domainlo(1),domainhi(1)
        do j=domainlo(2),domainhi(2)
        do k=domainlo(3),domainhi(3)+1 
         x=(i+half)*dx(1)
         y=(j+half)*dx(2)
         z=k*dx(3)
         state(i,j,k,QVEL3)=zero
         if (probtype.eq.4) then
          if ((adv_dir.eq.3).or.(adv_dir.eq.BL_SPACEDIM+1)) then
           state(i,j,k,QVEL3)=speed
          endif
         endif
        enddo
        enddo
        enddo


        call velocitybc(BL_FARG(state),bc,BL_BARG(domain),
     &   BL_BARG(domaingrow) )
 
        do i=domainlo(1),domainhi(1)
        do j=domainlo(2),domainhi(2)
        do k=domainlo(3),domainhi(3) 
         x=(i+half)*dx(1)
         y=(j+half)*dx(2)
         z=(k+half)*dx(3)
         call selectdist(state(i,j,k,QLEVEL),x,y,z)
        enddo
        enddo
        enddo
        call scalarbc(BL_FARG(state),bc,BL_BARG(domain),
     &   BL_BARG(domaingrow),QNUM,QLEVEL)

        do i=domainlo(1),domainhi(1)+1
        do j=domainlo(2),domainhi(2)+1
        do k=domainlo(3),domainhi(3)+1 
         x=i*dx(1)
         y=j*dx(2)
         z=k*dx(3)
         call selectdist(levelnode(i,j,k),x,y,z)
        enddo
        enddo
        enddo

        geomflag=1
        call liquidarea(BL_FARG(liquid_area),BL_FARG(state),
     &   BL_FARG(levelnode),BL_BARG(domain),BL_BARG(domaingrow),
     &   dx,bc,QNUM,QVFRAC,geomflag)

c modification if liquidonly is 1

        geomflag=0
        call liquidarea(BL_FARG(liquid_area),BL_FARG(work),
     &   BL_FARG(levelnode),BL_BARG(domain),BL_BARG(domaingrow),
     &   dx,bc,WNUM,WVOLFRACP,geomflag)

        do i=domaingrowlo(1),domaingrowhi(1)
        do j=domaingrowlo(2),domaingrowhi(2)
        do k=domaingrowlo(3),domaingrowhi(3)
         work(i,j,k,WSOLN)=zero
         do dir=1,BL_SPACEDIM
          state_area(i,j,k,dir)=one
         enddo
        enddo
        enddo
        enddo

        call project(BL_FARG(state),dx,bc,BL_BARG(domain),
     &    BL_BARG(domaingrow),BL_FARG(volfrac),BL_FARG(areafrac),
     &    BL_FARG(volume),BL_FARG(area),BL_FARG(state_area),BL_FARG(work),
     &    BL_FARG(liquid_area) )

        do i=domaingrowlo(1),domaingrowhi(1)
        do j=domaingrowlo(2),domaingrowhi(2)
        do k=domaingrowlo(3),domaingrowhi(3)
         work(i,j,k,WSOLN)=zero
        enddo
        enddo
        enddo

        if (1.eq.0) then
         call makedist(BL_BARG(domain),BL_BARG(domaingrow),
     &    BL_FARG(state),BL_FARG(work),BL_FARG(volfrac),dx,bc)
        endif

        return
        end


        subroutine FORT_COMPARE(BL_FARG(state1),BL_FARG(state2),
     &     BL_FARG(vfrac1),BL_FARG(vfrac2),
     &     BL_BARG(cbox),BL_BARG(fbox),ncomp )
        integer ncomp
        BL_FBOUNDS(state1) 
        BL_FBOUNDS(state2) 
        BL_FBOUNDS(vfrac1) 
        BL_FBOUNDS(vfrac2) 
        BL_BBOUNDS(cbox)
        BL_BBOUNDS(fbox)
        BL_FARRAY1(vfrac1)
        BL_FARRAY1(vfrac2)
        BL_FARRAY(state1,ncomp)
        BL_FARRAY(state2,ncomp)
        
        integer i,j,k,ifine,jfine,kfine,imax,jmax,kmax
        REAL_T fullcount,allcount
        REAL_T dx,velerrors(BL_SPACEDIM,6),coarse2(ncomp),errorhold(3)
        REAL_T presserrors(6)
        REAL_T test2

        fullcount=zero
        allcount=zero
        do i=1,BL_SPACEDIM
        do j=1,6
         velerrors(i,j)=zero
         presserrors(j)=zero
        enddo
        enddo
        do i=cboxlo(1),cboxhi(1)
        do j=cboxlo(2),cboxhi(2)
        do k=cboxlo(3),cboxhi(3)
         ifine=2*i
         jfine=2*j
         kfine=2*k
 
         if (fboxhi(1).eq.cboxhi(1)) then
          test2=vfrac2(i,j,k)
         else if ((vfrac2(ifine,jfine,kfine).gt.VOFTOL).and.
     &            (vfrac2(ifine+1,jfine,kfine).gt.VOFTOL).and.
     &            (vfrac2(ifine,jfine+1,kfine).gt.VOFTOL).and.
     &            (vfrac2(ifine+1,jfine+1,kfine).gt.VOFTOL).and.
     &            (vfrac2(ifine,jfine,kfine+1).gt.VOFTOL).and.
     &            (vfrac2(ifine+1,jfine,kfine+1).gt.VOFTOL).and.
     &            (vfrac2(ifine,jfine+1,kfine+1).gt.VOFTOL).and.
     &            (vfrac2(ifine+1,jfine+1,kfine+1).gt.VOFTOL)) then
          test2=vfrac1(i,j,k)
         else
          test2=zero
         endif

         if ((vfrac1(i,j,k).gt.VOFTOL).and.(test2.gt.VOFTOL)) then
          test2=(vfrac2(ifine,jfine,kfine)+vfrac2(ifine+1,jfine,kfine)+
     &     vfrac2(ifine,jfine+1,kfine)+vfrac2(ifine+1,jfine+1,kfine)+
     &     vfrac2(ifine,jfine,kfine+1)+vfrac2(ifine+1,jfine,kfine+1)+
     &     vfrac2(ifine,jfine+1,kfine+1)+vfrac2(ifine+1,jfine+1,kfine+1))/eight
          if ((test2.lt.one).or.(vfrac1(i,j,k).lt.one)) then
c          print *,"i,j,k,vcrse,vfine ",i,j,k,vfrac1(i,j,k),test2
          endif
          do n=1,ncomp
           if (fboxhi(1).eq.cboxhi(1)) then
            coarse2(n)=state2(i,j,k,n)
           else
            coarse2(n)=(state2(ifine,jfine,kfine,n)+
     &       state2(ifine+1,jfine+1,kfine,n)+
     &       state2(ifine,jfine+1,kfine,n)+
     &       state2(ifine+1,jfine,kfine,n)+
     &       state2(ifine,jfine,kfine+1,n)+
     &       state2(ifine+1,jfine+1,kfine+1,n)+
     &       state2(ifine,jfine+1,kfine+1,n)+
     &       state2(ifine+1,jfine,kfine+1,n))/eight
           endif
          enddo
          do n=1,BL_SPACEDIM
           errorhold(1)=abs(state1(i,j,k,n+QVEL1-1)-coarse2(n+QVEL1-1))
           errorhold(2)=abs(state1(i,j,k,n+QVEL1-1)-coarse2(n+QVEL1-1))**2
           velerrors(n,1)=velerrors(n,1)+errorhold(1)*vfrac1(i,j,k)
           velerrors(n,2)=velerrors(n,2)+errorhold(2)*vfrac1(i,j,k)
           if (errorhold(1).gt.velerrors(n,3)) then
            velerrors(n,3)=errorhold(1)
           endif 

           if (vfrac1(i,j,k).ge.one) then
            velerrors(n,4)=velerrors(n,4)+errorhold(1)*vfrac1(i,j,k)
            velerrors(n,5)=velerrors(n,5)+errorhold(2)*vfrac1(i,j,k)
            if (errorhold(1).gt.velerrors(n,6)) then
             velerrors(n,6)=errorhold(1)
            endif 
           endif
          enddo
c looping n


c         errorhold(1)=abs(state1(i,j,k,SPRES)-coarse2(SPRES))
c         errorhold(2)=abs(state1(i,j,k,SPRES)-coarse2(SPRES))**2
c         presserrors(1)=presserrors(1)+errorhold(1)*vfrac1(i,j,k)
c         presserrors(2)=presserrors(2)+errorhold(2)*vfrac1(i,j,k)
c         if (errorhold(1).gt.presserrors(3)) then
c           presserrors(3)=errorhold(1)
c           imax=i
c           jmax=j
c         endif 
          if (vfrac1(i,j,k).lt.one) then
c           print *,"i,j,k,crse,fine,err ",i,j,k,state1(i,j,k,SPRES),
c    &        coarse2(SPRES),errorhold(1)
c           print *,"if,jf,f,v ",ifine,jfine,state2(ifine,jfine,SPRES),
c    &        vfrac2(ifine,jfine)
c           print *,"if+1,jf,f,v ",ifine+1,jfine,state2(ifine+1,jfine,SPRES),
c    &        vfrac2(ifine+1,jfine)
c           print *,"if+1,jf+1,f,v ",ifine+1,jfine+1,
c    &        state2(ifine+1,jfine+1,SPRES),vfrac2(ifine+1,jfine+1)
c           print *,"if,jf+1,f,v ",ifine,jfine+1,state2(ifine,jfine+1,SPRES),
c    &        vfrac2(ifine,jfine+1)
          endif

c         if (vfrac1(i,j,k).ge.one) then
c           presserrors(4)=presserrors(4)+errorhold(1)*vfrac1(i,j,k)
c           presserrors(5)=presserrors(5)+errorhold(2)*vfrac1(i,j,k)
c           if (errorhold(1).gt.presserrors(6)) then
c            presserrors(6)=errorhold(1)
c           endif 
c         endif


          allcount=allcount+vfrac1(i,j,k)
          if (vfrac1(i,j,k).ge.one) then
            fullcount=fullcount+vfrac1(i,j,k)
          endif

         endif
c vfrac>VOFTOL

        enddo
        enddo
        enddo

        do n=1,BL_SPACEDIM
         velerrors(n,1)=velerrors(n,1)/allcount
         velerrors(n,2)=sqrt(velerrors(n,2)/allcount)
         velerrors(n,4)=velerrors(n,4)/fullcount
         velerrors(n,5)=sqrt(velerrors(n,5)/fullcount)
         print *,"part,n,L1,L2,max ",
     &     allcount,n,velerrors(n,1),velerrors(n,2),velerrors(n,3) 
         print *,"full,n,L1,L2,max ",
     &     fullcount,n,velerrors(n,4),velerrors(n,5),velerrors(n,6) 
        enddo
c       presserrors(1)=presserrors(1)/allcount
c       presserrors(2)=sqrt(presserrors(2)/allcount)
c       presserrors(4)=presserrors(4)/fullcount
c       presserrors(5)=sqrt(presserrors(5)/fullcount)
c       print *,"part,pressure,L1,L2,max ",
c    &     allcount,presserrors(1),presserrors(2),presserrors(3)
c       print *,"full,press,L1,L2,max ",
c    &     fullcount,presserrors(4),presserrors(5),presserrors(6)

c       print *,"imax,jmax,vfrac1 ",imax,jmax,vfrac1(imax,jmax)

        return
        end

        subroutine FORT_MASKOFF(BL_FARG(state),BL_FARG(smallstate),
     &    BL_FARG(volfrac),BL_FARG(smallvolfrac),
     &    BL_FARG(mask),BL_FARG(smallmask),
     &    BL_BARG(domain),BL_BARG(domaingrow) )
        BL_BBOUNDS(domain)
        BL_BBOUNDS(domaingrow)
        BL_FBOUNDS(state)
        BL_FBOUNDS(smallstate)
        BL_FBOUNDS(volfrac)
        BL_FBOUNDS(smallvolfrac)
        BL_FBOUNDS(mask)
        BL_FBOUNDS(smallmask)

        BL_FARRAY(state,QNUM)
        BL_FARRAY(smallstate,QNUM)
        BL_FARRAY1(volfrac)
        BL_FARRAY1(smallvolfrac)

	integer mask(maskloi1:maskhii1,maskloi2:maskhii2,maskloi3:maskhii3)
	integer smallmask(smallmaskloi1:smallmaskhii1,
     &                    smallmaskloi2:smallmaskhii2,
     &                    smallmaskloi3:smallmaskhii3)

        integer i,j,k

        do i=domainlo(1),domainhi(1)
        do j=domainlo(2),domainhi(2)
        do k=domainlo(3),domainhi(3) 
         if (volfrac(i,j,k).eq.zero) then
          smallstate(i,j,k,QVFRAC)=zero
          smallstate(i,j,k,QLEVEL)=zero
          smallstate(i,j,k,QVEL1)=zero
          smallstate(i,j,k,QVEL2)=zero
         else
          smallstate(i,j,k,QVFRAC)=state(i,j,k,QVFRAC)
          smallstate(i,j,k,QLEVEL)=state(i,j,k,QLEVEL)
          smallstate(i,j,k,QVEL1)=(state(i,j,k,QVEL1)+state(i+1,j,k,QVEL1))/two
          smallstate(i,j,k,QVEL2)=(state(i,j,k,QVEL2)+state(i,j+1,k,QVEL2))/two
          smallstate(i,j,k,QVEL3)=(state(i,j,k,QVEL3)+state(i,j,k+1,QVEL3))/two
         endif

         smallvolfrac(i,j,k)=volfrac(i,j,k)
         smallmask(i,j,k)=mask(i,j,k)
        enddo
        enddo
        enddo

        return
        end

