/************************************************************* 
 *
 * Marching Cubes
 *
 * "Polygonising a scalar field"
 * http://www.swin.edu.au/astronomy/pbourke/modelling/polygonise/
 * Written by Paul Bourke
 * Based on tables by Cory Gene Bloyd
 * May 1997 
 *
 *************************************************************/

#include <Inventor/nodes/SoFaceSet.h>
#include <Inventor/SbLinear.h>
#include <Inventor/nodes/SoCoordinate3.h>
#include <Inventor/nodes/SoIndexedFaceSet.h>
#include <Inventor/nodes/SoSeparator.h>


extern int edgeTable[256];
extern int32_t triTable[256][20];
extern int32_t numTris[256];

void
vertexInterp(double isovalue, const SbVec4f &p1, const SbVec4f &p2, SbVec3f &p);



int 
polygonize(const SbVec4f *grid, double isovalue, SbVec3f *point,
	       SoIndexedFaceSet *faceSet, SoSeparator *root);

