#include<fstream.h>
#include<stdio.h>

//
// Reads ASCII restart ("check") input file and writes it out
// in binary for Amira to read.
//
// Kevin Beason 4/26/2000
//

int main(int argc, char* argv[]){

  const int NGROW=3;
  const int localnx=128;
  const int localny=96;
  const int localnz=96;
  const int imax=2*NGROW+localnx;
  const int jmax=2*NGROW+localny;
  const int kmax=2*NGROW+localnz;

  
  // read in data
  ifstream checkFile;
  cout << "Reading from data file: check\n";
  cout << "Writing to data file: check.qlevel\n";
  checkFile.open("/home/beason/sussman/check");
  double qlevel, trash;
  int i, j, k;

  // open outputfile
  //ofstream niceCheckFile;
  //niceCheckFile.open("/home/beason/sussman/check.qlevel", ios::binary);
  //niceCheckFile.precision(16);
  //niceCheckFile.setf(ios::scientific,ios::floatfield);
  FILE *niceCheckFile;
  niceCheckFile=fopen("/home/beason/sussman/check.qlevel", "wb");
  
  checkFile >> trash >> trash;

  cout << "Reading i = (0.." << imax << ") ";
  for (i=0;i<imax;i++){
    cout << i << " " << flush;
    for (j=0;j<jmax;j++)
      for (k=0;k<kmax;k++){
	checkFile >> trash >> qlevel >> trash >> trash >> trash >> trash;
	//niceCheckFile << qlevel; // << endl;
	//fprintf(niceCheckFile, "%lf", qlevel);
	if (i>=NGROW && i<(imax-NGROW) &&
	    j>=NGROW && j<(jmax-NGROW) &&
	    k>=NGROW && k<(kmax-NGROW))
	fwrite(&qlevel, sizeof(qlevel), 1, niceCheckFile);
      }

  }

  cout << "\nClosing files: check, check.qlevel\n";
  checkFile.close();
  //niceCheckFile.close();
  fclose(niceCheckFile);

  cout << "Done.\n";

  return(0);
}
